/*----- PROTECTED REGION ID(AxisG2Scan.cpp) ENABLED START -----*/
//=============================================================================
//
// file :        AxisG2Scan.cpp
//
// description : C++ source for the AxisG2Scan class and its commands.
//               The class is derived from Device. It represents the
//               CORBA servant object which will be accessed from the
//               network. All commands which can be executed on the
//               AxisG2Scan are implemented in this file.
//
// project :     
//
// This file is part of Tango device class.
// 
// Tango is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
// 
// Tango is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// 
// You should have received a copy of the GNU General Public License
// along with Tango.  If not, see <http://www.gnu.org/licenses/>.
// 
//
//
//=============================================================================
//                This file is generated by POGO
//        (Program Obviously used to Generate tango Object)
//=============================================================================


#include <AxisG2Scan.h>
#include <AxisG2ScanClass.h>

#include "FSM.h"

/*----- PROTECTED REGION END -----*/	//	AxisG2Scan.cpp

/**
 *  AxisG2Scan class description:
 *    
 */

//================================================================
//  The following table gives the correspondence
//  between command and method names.
//
//  Command name  |  Method name
//================================================================
//  State         |  Inherited (no method)
//  Status        |  Inherited (no method)
//  Start         |  start
//  Stop          |  stop
//  RevStart      |  rev_start
//================================================================

//================================================================
//  Attributes managed are:
//================================================================
//  ScanBegin         |  Tango::DevDouble	Scalar
//  ScanEnd           |  Tango::DevDouble	Scalar
//  ScanSpeed         |  Tango::DevDouble	Scalar
//  ScanAcceleration  |  Tango::DevDouble	Scalar
//  ScanDeceleration  |  Tango::DevDouble	Scalar
//  ScanFSM           |  Tango::DevString	Scalar
//  ScanBeginBN       |  Tango::DevLong	Scalar
//  ScanEndBN         |  Tango::DevLong	Scalar
//  Position          |  Tango::DevDouble	Scalar
//  ScanTotalTime     |  Tango::DevDouble	Scalar
//  ExtStatus         |  Tango::DevString	Spectrum  ( max = 100)
//  ScanPositions     |  Tango::DevDouble	Spectrum  ( max = 10000)
//  ScanBN            |  Tango::DevLong	Spectrum  ( max = 10000)
//================================================================

namespace AxisG2Scan_ns
{
/*----- PROTECTED REGION ID(AxisG2Scan::namespace_starting) ENABLED START -----*/

//	static initializations

/*----- PROTECTED REGION END -----*/	//	AxisG2Scan::namespace_starting

//--------------------------------------------------------
/**
 *	Method      : AxisG2Scan::AxisG2Scan()
 *	Description : Constructors for a Tango device
 *                implementing the classAxisG2Scan
 */
//--------------------------------------------------------
AxisG2Scan::AxisG2Scan(Tango::DeviceClass *cl, string &s)
 : TANGO_BASE_CLASS(cl, s.c_str())
{
	/*----- PROTECTED REGION ID(AxisG2Scan::constructor_1) ENABLED START -----*/
	init_device();
	
	/*----- PROTECTED REGION END -----*/	//	AxisG2Scan::constructor_1
}
//--------------------------------------------------------
AxisG2Scan::AxisG2Scan(Tango::DeviceClass *cl, const char *s)
 : TANGO_BASE_CLASS(cl, s)
{
	/*----- PROTECTED REGION ID(AxisG2Scan::constructor_2) ENABLED START -----*/
	init_device();
	
	/*----- PROTECTED REGION END -----*/	//	AxisG2Scan::constructor_2
}
//--------------------------------------------------------
AxisG2Scan::AxisG2Scan(Tango::DeviceClass *cl, const char *s, const char *d)
 : TANGO_BASE_CLASS(cl, s, d)
{
	/*----- PROTECTED REGION ID(AxisG2Scan::constructor_3) ENABLED START -----*/
	init_device();
	
	/*----- PROTECTED REGION END -----*/	//	AxisG2Scan::constructor_3
}

//--------------------------------------------------------
/**
 *	Method      : AxisG2Scan::delete_device()
 *	Description : will be called at device destruction or at init command
 */
//--------------------------------------------------------
void AxisG2Scan::delete_device()
{
	DEBUG_STREAM << "AxisG2Scan::delete_device() " << device_name << endl;
	/*----- PROTECTED REGION ID(AxisG2Scan::delete_device) ENABLED START -----*/
	
	//	Delete device allocated objects

#ifdef __STOP_ON_DELETE_DEVICE__
	if (axis_dp) {
		try {
			axis_dp->command_inout("Stop");
		} catch (...) {
			cout << "error on stop() on delete_device()" << endl;
		}
	}
#endif
	if (scanfsm){
		__attribute__ ((unused)) int retfsm = scanfsm->fsm(FSM_ns::FSMT_STOP);
		delete scanfsm;
		scanfsm = NULL;
	}
	

	if (axis_dp) {
		delete axis_dp;
		axis_dp = NULL;
	}

	if (drv_dp) {
		delete drv_dp;
		drv_dp = NULL;
	}

	if (attr_ScanFSM_read[0] != NULL){
        	delete[] attr_ScanFSM_read[0];
                attr_ScanFSM_read[0] = NULL;
       	}

        for (int i=0; i<100; i++){
                if (attr_ExtStatus_read[i] != NULL){
                        delete[] attr_ExtStatus_read[i];
                        attr_ExtStatus_read[i] = NULL;
                }
        }

	if (axisBuffer_dp) {
		delete axisBuffer_dp;
		axisBuffer_dp = NULL;
	}

	drv_attrpoll.erase (drv_attrpoll.begin(),drv_attrpoll.end());
	axis_attrpoll.erase (axis_attrpoll.begin(),axis_attrpoll.end());

	
	/*----- PROTECTED REGION END -----*/	//	AxisG2Scan::delete_device
	delete[] attr_ScanBegin_read;
	delete[] attr_ScanEnd_read;
	delete[] attr_ScanSpeed_read;
	delete[] attr_ScanAcceleration_read;
	delete[] attr_ScanDeceleration_read;
	delete[] attr_ScanFSM_read;
	delete[] attr_ScanBeginBN_read;
	delete[] attr_ScanEndBN_read;
	delete[] attr_Position_read;
	delete[] attr_ScanTotalTime_read;
	delete[] attr_ExtStatus_read;
	delete[] attr_ScanPositions_read;
	delete[] attr_ScanBN_read;
}

//--------------------------------------------------------
/**
 *	Method      : AxisG2Scan::init_device()
 *	Description : will be called at device initialization.
 */
//--------------------------------------------------------
void AxisG2Scan::init_device()
{
	DEBUG_STREAM << "AxisG2Scan::init_device() create device " << device_name << endl;
	/*----- PROTECTED REGION ID(AxisG2Scan::init_device_before) ENABLED START -----*/
	
	//	Initialization before get_device_property() call
	
	/*----- PROTECTED REGION END -----*/	//	AxisG2Scan::init_device_before
	

	//	Get the device properties from database
	get_device_property();
	
	attr_ScanBegin_read = new Tango::DevDouble[1];
	attr_ScanEnd_read = new Tango::DevDouble[1];
	attr_ScanSpeed_read = new Tango::DevDouble[1];
	attr_ScanAcceleration_read = new Tango::DevDouble[1];
	attr_ScanDeceleration_read = new Tango::DevDouble[1];
	attr_ScanFSM_read = new Tango::DevString[1];
	attr_ScanBeginBN_read = new Tango::DevLong[1];
	attr_ScanEndBN_read = new Tango::DevLong[1];
	attr_Position_read = new Tango::DevDouble[1];
	attr_ScanTotalTime_read = new Tango::DevDouble[1];
	attr_ExtStatus_read = new Tango::DevString[100];
	attr_ScanPositions_read = new Tango::DevDouble[10000];
	attr_ScanBN_read = new Tango::DevLong[10000];
	//	No longer if mandatory property not set. 
	if (mandatoryNotDefined)
		return;

	/*----- PROTECTED REGION ID(AxisG2Scan::init_device) ENABLED START -----*/
	
	//	Initialize device

        // MYCODE-START

        set_state(Tango::INIT);
        set_status("Initialization");
	bool init_device_ok = true;

	#ifdef _DBG_DEVICE_INIT
		cout << device_name << " , on : " << axisDevice << endl;
	#endif /* _DBG_DEVICE_INIT */

        axis_dp = NULL;
        drv_dp  = NULL;

	//==================================================
	try {
		axis_dp = new Tango::DeviceProxy(axisDevice);
	} catch (...) {
		string ss(ag2sc_error_str(AG2SC_E000));
		ss.append(" : exception on Tango::DeviceProxy(" + axisDevice + ")!");
		cout << ss << endl;
		append_status(ss, true);
		init_device_ok &= false;
	}

	vector<string> *att_list = NULL;	
	max_axisDevice_poll_time = 0;

	//
	//
	//	------ Otteniamo i tempi di polling per axisDevice ------
	//
	try {
		att_list = axis_dp->get_attribute_list();	

		vector<string>::iterator it;
		int poll_period = -1;

		for (it = att_list->begin(); it != att_list->end(); ++it){
			poll_period = -1;
			if (axis_dp->is_attribute_polled(*it)){

				poll_period = axis_dp->get_attribute_poll_period(*it);
				max_axisDevice_poll_time = poll_period > max_axisDevice_poll_time ? poll_period : max_axisDevice_poll_time;

				#ifdef _DBG_DEVICE_INIT
					cout << device_name << " : polled,period : " << *it << "," << poll_period << endl;
				#endif /* _DBG_DEVICE_INIT */
				attrpoll_t ap;
				ap.attr = *it;
				ap.poll_period = poll_period;
				axis_attrpoll.push_back(ap);
			}
		}

		vector<attrpoll_t>::iterator apit;
		cout << endl << "------------  axisDevice polling vector  -----------------" << endl;
		for (apit=axis_attrpoll.begin(); apit!=axis_attrpoll.end(); ++apit){
			cout << device_name << " : polled,period : " << (*apit).attr << "," << (*apit).poll_period << endl;
		}
		cout << endl;
		
	} catch (...) {
		string ss(ag2sc_error_str(AG2SC_E001));
		ss.append(" : exception on Tango::DeviceProxy(" + axisDevice + ")!");
		cout << ss << endl;
		append_status(ss, true);
		init_device_ok &= false;
	}
	if (att_list) {
		delete att_list;
		att_list = NULL;
	}
	//==================================================

#ifdef _RD_SPACDC_AT_INIT

	string msg("");
	try {
		axis_default_data = getspacdc(msg);
	} catch (...) {
		cout << msg << endl;
		append_status(msg, true);
		init_device_ok &= false;
	}

	#ifdef _DBG_DEVICE_INIT
		cout << device_name << " : axis_default_data.speed : " << axis_default_data.speed  << endl;
		cout << device_name << " : axis_default_data.accel : " << axis_default_data.accel  << endl;
		cout << device_name << " : axis_default_data.decel : " << axis_default_data.decel  << endl;
	#endif /* _DBG_DEVICE_INIT */
#endif

	//==================================================
	Tango::DbData dbdata;
	axis_driver = "?";
	string axis_prop("Driver");
	try {
		axis_dp->get_property(axis_prop, dbdata);
		if (dbdata[0].is_empty()==false) dbdata[0] >> axis_driver;

		#ifdef __KEN__
			string th(TH);
			cout << "|" << th << "|" << endl;
			th += axis_driver;
			axis_driver = th;
		#endif /* __KEN__ */

		#ifdef _DBG_DEVICE_INIT
			cout << device_name << " : axis_driver : |" << axis_driver << "|" << endl;
		#endif /* _DBG_DEVICE_INIT */
	} catch (...) {
		string ss(ag2sc_error_str(AG2SC_E002));
		ss.append(" : exception on Tango::DeviceProxy(" + axisDevice + ")!");
		cout << ss << endl;
		append_status(ss, true);
		init_device_ok &= false;
	}

	if ( axis_driver.empty() ){
		string ss(ag2sc_error_str(AG2SC_E003));
		ss.append(" : exception on Tango::DeviceProxy(" + axisDevice + ")!");
		cout << ss << endl;
		append_status(ss, true);
		init_device_ok &= false;
	
		goto init_end;
	}
	//==================================================
	axis_channel = "?";
	axis_prop = "Channel";
	char c;
	try {
		axis_dp->get_property(axis_prop, dbdata);
		if (dbdata[0].is_empty()==false) dbdata[0] >> axis_channel;

		#ifdef _DBG_DEVICE_INIT
			cout << device_name << " : axis_channel : |" << axis_channel << "|" << endl;
		#endif /* _DBG_DEVICE_INIT */
	} catch (...) {
		string ss(ag2sc_error_str(AG2SC_E002));
		ss.append(" : exception on Tango::DeviceProxy(" + axisDevice + ")!");
		cout << ss << endl;
		append_status(ss, true);
		init_device_ok &= false;
	}

	if ( axis_channel.empty() || (axis_channel.size() != 1) ){
		string ss(ag2sc_error_str(AG2SC_E007));
		ss.append(" : exception on Tango::DeviceProxy(" + axisDevice + ")!");
		cout << ss << endl;
		append_status(ss, true);
		init_device_ok &= false;
	
		goto init_end;
	}
	c = axis_channel.c_str()[0];
	switch (c){
		case 'A': channel_no = 0; break;
		case 'B': channel_no = 1; break;
		case 'C': channel_no = 2; break;
		case 'D': channel_no = 3; break;
		case 'E': channel_no = 4; break;
		case 'F': channel_no = 5; break;
		case 'G': channel_no = 6; break;
		case 'H': channel_no = 7; break;
		default: break;
	}
	//==================================================
	per = NAN;
	axis_prop = "PositionEncoderRatio";
	try {
		axis_dp->get_property(axis_prop, dbdata);
		if (dbdata[0].is_empty()==false) dbdata[0] >> per;

		#ifdef _DBG_DEVICE_INIT
			cout << device_name << " : per : |" << per << "|" << endl;
		#endif /* _DBG_DEVICE_INIT */
	} catch (...) {
		string ss(ag2sc_error_str(AG2SC_E002));
		ss.append(" : exception on Tango::DeviceProxy(" + axisDevice + ")!");
		cout << ss << endl;
		append_status(ss, true);
		init_device_ok &= false;
	}

	if ( isnan(per) ){
		string ss(ag2sc_error_str(AG2SC_E008));
		ss.append(" : exception on Tango::DeviceProxy(" + axisDevice + ")!");
		cout << ss << endl;
		append_status(ss, true);
		init_device_ok &= false;
	
		goto init_end;
	}
	//==================================================
	peo = NAN;
	axis_prop = "PositionEncoderOffset";
	try {
		axis_dp->get_property(axis_prop, dbdata);
		if (dbdata[0].is_empty()==false) dbdata[0] >> peo;

		#ifdef _DBG_DEVICE_INIT
			cout << device_name << " : peo : |" << peo << "|" << endl;
		#endif /* _DBG_DEVICE_INIT */
	} catch (...) {
		string ss(ag2sc_error_str(AG2SC_E002));
		ss.append(" : exception on Tango::DeviceProxy(" + axisDevice + ")!");
		cout << ss << endl;
		append_status(ss, true);
		init_device_ok &= false;
	}

	if ( isnan(peo) ){
		string ss(ag2sc_error_str(AG2SC_E009));
		ss.append(" : exception on Tango::DeviceProxy(" + axisDevice + ")!");
		cout << ss << endl;
		append_status(ss, true);
		init_device_ok &= false;
	
		goto init_end;
	}
	try {
		drv_dp = new Tango::DeviceProxy(axis_driver);
	} catch (...) {
		string ss(ag2sc_error_str(AG2SC_E000));
		ss.append(" : exception on Tango::DeviceProxy(" + axisDevice + ")!");
		cout << ss << endl;
		append_status(ss, true);
		init_device_ok &= false;
	}

	//vector<string> *att_list = NULL;	

	//
	//
	//	------ Otteniamo i tempi di polling per axis_driver ------
	//
	//	... saranno usati in drv_attrpoll_off() / drv_attrpoll_on()
	//
	try {
		att_list = drv_dp->get_attribute_list();	

		vector<string>::iterator it;
		int poll_period = -1;

		for (it = att_list->begin(); it != att_list->end(); ++it){
			poll_period = -1;
			if (drv_dp->is_attribute_polled(*it)){

				poll_period = drv_dp->get_attribute_poll_period(*it);

				#ifdef _DBG_DEVICE_INIT
					cout << device_name << " : polled,period : " << *it << "," << poll_period << endl;
				#endif /* _DBG_DEVICE_INIT */
				attrpoll_t ap;
				ap.attr = *it;
				ap.poll_period = poll_period;
				drv_attrpoll.push_back(ap);
			}
		}

		vector<attrpoll_t>::iterator apit;
		cout << endl << "------------  axis_driver polling vector  -----------------" << endl;
		for (apit=drv_attrpoll.begin(); apit!=drv_attrpoll.end(); ++apit){
			cout << device_name << " : polled,period : " << (*apit).attr << "," << (*apit).poll_period << endl;
		}
		cout << endl;
		
	} catch (...) {
		string ss(ag2sc_error_str(AG2SC_E001));
		ss.append(" : exception on Tango::DeviceProxy(" + axisDevice + ")!");
		cout << ss << endl;
		append_status(ss, true);
		init_device_ok &= false;
	}
	if (att_list) {
		delete att_list;
		att_list = NULL;
	}
	//==================================================
	try {
		axisBuffer_dp = new Tango::DeviceProxy(axisBufferDevice);
	} catch (...) {
		string ss(ag2sc_error_str(AG2SC_E006));
		ss.append(" : exception on Tango::DeviceProxy(" + axisBufferDevice + ")!");
		cout << ss << endl;
		append_status(ss, true);
		init_device_ok &= false;
	}

	*attr_ScanBeginBN_read = -1;
	*attr_ScanEndBN_read = -1;

        for (int i=0; i<10000; i++){
        	attr_ScanPositions_read[i] = 0.0;
        	attr_ScanBN_read[i] = -1;
	}

	//==================================================

	*attr_ScanFSM_read=Tango::string_dup("-?-");

	scanfsm = new FSM_ns::FSM(this);
	scanfsm->verbose(0);

	//==================================================


        for (int i=0; i<100; i++){
                attr_ExtStatus_read[i] = new char[2];
                strcpy(attr_ExtStatus_read[i], "-");
        }

	//==================================================
	gettimeofday(&extStatus_lastAcq_time, NULL);


	//==================================================
	*attr_ScanTotalTime_read = -1;

init_end:
        if (init_device_ok) {
                set_state(Tango::ON);
                set_status("Initialization done.");
        } else {
                set_state(Tango::FAULT);
        }
        // MYCODE-END


	
	/*----- PROTECTED REGION END -----*/	//	AxisG2Scan::init_device
}

//--------------------------------------------------------
/**
 *	Method      : AxisG2Scan::get_device_property()
 *	Description : Read database to initialize property data members.
 */
//--------------------------------------------------------
void AxisG2Scan::get_device_property()
{
	/*----- PROTECTED REGION ID(AxisG2Scan::get_device_property_before) ENABLED START -----*/
	
	//	Initialize property data members
	
	/*----- PROTECTED REGION END -----*/	//	AxisG2Scan::get_device_property_before

	mandatoryNotDefined = false;

	//	Read device properties from database.
	Tango::DbData	dev_prop;
	dev_prop.push_back(Tango::DbDatum("AxisDevice"));
	dev_prop.push_back(Tango::DbDatum("AxisBufferDevice"));
	dev_prop.push_back(Tango::DbDatum("AxisPollOff"));

	//	is there at least one property to be read ?
	if (dev_prop.size()>0)
	{
		//	Call database and extract values
		if (Tango::Util::instance()->_UseDb==true)
			get_db_device()->get_property(dev_prop);
	
		//	get instance on AxisG2ScanClass to get class property
		Tango::DbDatum	def_prop, cl_prop;
		AxisG2ScanClass	*ds_class =
			(static_cast<AxisG2ScanClass *>(get_device_class()));
		int	i = -1;

		//	Try to initialize AxisDevice from class property
		cl_prop = ds_class->get_class_property(dev_prop[++i].name);
		if (cl_prop.is_empty()==false)	cl_prop  >>  axisDevice;
		else {
			//	Try to initialize AxisDevice from default device value
			def_prop = ds_class->get_default_device_property(dev_prop[i].name);
			if (def_prop.is_empty()==false)	def_prop  >>  axisDevice;
		}
		//	And try to extract AxisDevice value from database
		if (dev_prop[i].is_empty()==false)	dev_prop[i]  >>  axisDevice;
		//	Property StartDsPath is mandatory, check if has been defined in database.
		check_mandatory_property(cl_prop, dev_prop[i]);

		//	Try to initialize AxisBufferDevice from class property
		cl_prop = ds_class->get_class_property(dev_prop[++i].name);
		if (cl_prop.is_empty()==false)	cl_prop  >>  axisBufferDevice;
		else {
			//	Try to initialize AxisBufferDevice from default device value
			def_prop = ds_class->get_default_device_property(dev_prop[i].name);
			if (def_prop.is_empty()==false)	def_prop  >>  axisBufferDevice;
		}
		//	And try to extract AxisBufferDevice value from database
		if (dev_prop[i].is_empty()==false)	dev_prop[i]  >>  axisBufferDevice;
		//	Property StartDsPath is mandatory, check if has been defined in database.
		check_mandatory_property(cl_prop, dev_prop[i]);

		//	Try to initialize AxisPollOff from class property
		cl_prop = ds_class->get_class_property(dev_prop[++i].name);
		if (cl_prop.is_empty()==false)	cl_prop  >>  axisPollOff;
		else {
			//	Try to initialize AxisPollOff from default device value
			def_prop = ds_class->get_default_device_property(dev_prop[i].name);
			if (def_prop.is_empty()==false)	def_prop  >>  axisPollOff;
		}
		//	And try to extract AxisPollOff value from database
		if (dev_prop[i].is_empty()==false)	dev_prop[i]  >>  axisPollOff;
		//	Property StartDsPath is mandatory, check if has been defined in database.
		check_mandatory_property(cl_prop, dev_prop[i]);

	}

	/*----- PROTECTED REGION ID(AxisG2Scan::get_device_property_after) ENABLED START -----*/
	
	//	Check device property data members init
	
	/*----- PROTECTED REGION END -----*/	//	AxisG2Scan::get_device_property_after
}
//--------------------------------------------------------
/**
 *	Method      : AxisG2Scan::check_mandatory_property()
 *	Description : For mandatory properties check if defined in database.
 */
//--------------------------------------------------------
void AxisG2Scan::check_mandatory_property(Tango::DbDatum &class_prop, Tango::DbDatum &dev_prop)
{
	//	Check if all properties are empty
	if (class_prop.is_empty() && dev_prop.is_empty())
	{
		TangoSys_OMemStream	tms;
		tms << endl <<"Property \'" << dev_prop.name;
		if (Tango::Util::instance()->_UseDb==true)
			tms << "\' is mandatory but not defined in database";
		else
			tms << "\' is mandatory but cannot be defined without database";
		string	status(get_status());
		status += tms.str();
		set_status(status);
		mandatoryNotDefined = true;
		/*----- PROTECTED REGION ID(AxisG2Scan::check_mandatory_property) ENABLED START -----*/
		cerr << tms.str() << " for " << device_name << endl;
		
		/*----- PROTECTED REGION END -----*/	//	AxisG2Scan::check_mandatory_property
	}
}


//--------------------------------------------------------
/**
 *	Method      : AxisG2Scan::always_executed_hook()
 *	Description : method always executed before any command is executed
 */
//--------------------------------------------------------
void AxisG2Scan::always_executed_hook()
{
	DEBUG_STREAM << "AxisG2Scan::always_executed_hook()  " << device_name << endl;
	if (mandatoryNotDefined)
	{
		string	status(get_status());
		Tango::Except::throw_exception(
					(const char *)"PROPERTY_NOT_SET",
					status.c_str(),
					(const char *)"AxisG2Scan::always_executed_hook()");
	}
	/*----- PROTECTED REGION ID(AxisG2Scan::always_executed_hook) ENABLED START -----*/
	
	//	code always executed before all requests

	switch (retfsm){
        	case FSM_ns::FSM_ERROR:
        	case FSM_ns::FSM_NOTINITED:
			set_status("Error!");
			break;
        	case FSM_ns::FSM_INITIALIZING:
			set_status("FSM initializing...");
			break;
        	case FSM_ns::FSM_WAIT:
			set_status("Ready...");
			break;
        	case FSM_ns::FSM_START:
        	case FSM_ns::FSM_MOVING:
        	case FSM_ns::FSM_POSITIONING:
        	case FSM_ns::FSM_POSITIONING_WAIT:
			set_status("Positioning...");
			break;
        	case FSM_ns::FSM_SCAN:
        	case FSM_ns::FSM_SCAN_WAIT_TIME:
        	case FSM_ns::FSM_SCAN_WAIT:
        	case FSM_ns::FSM_SCAN_END:
			set_status("Scanning...");
			break;
        	case FSM_ns::FSM_STOP:
			set_status("Stopping...");
			break;
        	case FSM_ns::FSM_STOP_ERROR:
			set_status("ALARM:: Error on stopping...");
			break;
		default:
			break;
	}
	
	/*----- PROTECTED REGION END -----*/	//	AxisG2Scan::always_executed_hook
}

//--------------------------------------------------------
/**
 *	Method      : AxisG2Scan::read_attr_hardware()
 *	Description : Hardware acquisition for attributes
 */
//--------------------------------------------------------
void AxisG2Scan::read_attr_hardware(TANGO_UNUSED(vector<long> &attr_list))
{
	DEBUG_STREAM << "AxisG2Scan::read_attr_hardware(vector<long> &attr_list) entering... " << endl;
	/*----- PROTECTED REGION ID(AxisG2Scan::read_attr_hardware) ENABLED START -----*/
	
	//	Add your own code
	
	/*----- PROTECTED REGION END -----*/	//	AxisG2Scan::read_attr_hardware
}
//--------------------------------------------------------
/**
 *	Method      : AxisG2Scan::write_attr_hardware()
 *	Description : Hardware writing for attributes
 */
//--------------------------------------------------------
void AxisG2Scan::write_attr_hardware(TANGO_UNUSED(vector<long> &attr_list))
{
	DEBUG_STREAM << "AxisG2Scan::write_attr_hardware(vector<long> &attr_list) entering... " << endl;
	/*----- PROTECTED REGION ID(AxisG2Scan::write_attr_hardware) ENABLED START -----*/
	
	//	Add your own code
	
	/*----- PROTECTED REGION END -----*/	//	AxisG2Scan::write_attr_hardware
}

//--------------------------------------------------------
/**
 *	Read attribute ScanBegin related method
 *	Description: 
 *
 *	Data type:	Tango::DevDouble
 *	Attr type:	Scalar
 */
//--------------------------------------------------------
void AxisG2Scan::read_ScanBegin(Tango::Attribute &attr)
{
	DEBUG_STREAM << "AxisG2Scan::read_ScanBegin(Tango::Attribute &attr) entering... " << endl;
	/*----- PROTECTED REGION ID(AxisG2Scan::read_ScanBegin) ENABLED START -----*/
	//	Set the attribute value
	attr.set_value(attr_ScanBegin_read);
	
	/*----- PROTECTED REGION END -----*/	//	AxisG2Scan::read_ScanBegin
}
//--------------------------------------------------------
/**
 *	Write attribute ScanBegin related method
 *	Description: 
 *
 *	Data type:	Tango::DevDouble
 *	Attr type:	Scalar
 */
//--------------------------------------------------------
void AxisG2Scan::write_ScanBegin(Tango::WAttribute &attr)
{
	DEBUG_STREAM << "AxisG2Scan::write_ScanBegin(Tango::WAttribute &attr) entering... " << endl;
	//	Retrieve write value
	Tango::DevDouble	w_val;
	attr.get_write_value(w_val);
	/*----- PROTECTED REGION ID(AxisG2Scan::write_ScanBegin) ENABLED START -----*/

	*attr_ScanBegin_read = w_val;
	axis_scan_data.begin = *attr_ScanBegin_read;
	
	/*----- PROTECTED REGION END -----*/	//	AxisG2Scan::write_ScanBegin
}
//--------------------------------------------------------
/**
 *	Read attribute ScanEnd related method
 *	Description: 
 *
 *	Data type:	Tango::DevDouble
 *	Attr type:	Scalar
 */
//--------------------------------------------------------
void AxisG2Scan::read_ScanEnd(Tango::Attribute &attr)
{
	DEBUG_STREAM << "AxisG2Scan::read_ScanEnd(Tango::Attribute &attr) entering... " << endl;
	/*----- PROTECTED REGION ID(AxisG2Scan::read_ScanEnd) ENABLED START -----*/
	//	Set the attribute value
	attr.set_value(attr_ScanEnd_read);
	
	/*----- PROTECTED REGION END -----*/	//	AxisG2Scan::read_ScanEnd
}
//--------------------------------------------------------
/**
 *	Write attribute ScanEnd related method
 *	Description: 
 *
 *	Data type:	Tango::DevDouble
 *	Attr type:	Scalar
 */
//--------------------------------------------------------
void AxisG2Scan::write_ScanEnd(Tango::WAttribute &attr)
{
	DEBUG_STREAM << "AxisG2Scan::write_ScanEnd(Tango::WAttribute &attr) entering... " << endl;
	//	Retrieve write value
	Tango::DevDouble	w_val;
	attr.get_write_value(w_val);
	/*----- PROTECTED REGION ID(AxisG2Scan::write_ScanEnd) ENABLED START -----*/
	
	*attr_ScanEnd_read = w_val;
	axis_scan_data.end = *attr_ScanEnd_read;
	
	/*----- PROTECTED REGION END -----*/	//	AxisG2Scan::write_ScanEnd
}
//--------------------------------------------------------
/**
 *	Read attribute ScanSpeed related method
 *	Description: 
 *
 *	Data type:	Tango::DevDouble
 *	Attr type:	Scalar
 */
//--------------------------------------------------------
void AxisG2Scan::read_ScanSpeed(Tango::Attribute &attr)
{
	DEBUG_STREAM << "AxisG2Scan::read_ScanSpeed(Tango::Attribute &attr) entering... " << endl;
	/*----- PROTECTED REGION ID(AxisG2Scan::read_ScanSpeed) ENABLED START -----*/
	//	Set the attribute value
	attr.set_value(attr_ScanSpeed_read);
	
	/*----- PROTECTED REGION END -----*/	//	AxisG2Scan::read_ScanSpeed
}
//--------------------------------------------------------
/**
 *	Write attribute ScanSpeed related method
 *	Description: 
 *
 *	Data type:	Tango::DevDouble
 *	Attr type:	Scalar
 */
//--------------------------------------------------------
void AxisG2Scan::write_ScanSpeed(Tango::WAttribute &attr)
{
	DEBUG_STREAM << "AxisG2Scan::write_ScanSpeed(Tango::WAttribute &attr) entering... " << endl;
	//	Retrieve write value
	Tango::DevDouble	w_val;
	attr.get_write_value(w_val);
	/*----- PROTECTED REGION ID(AxisG2Scan::write_ScanSpeed) ENABLED START -----*/
	
	*attr_ScanSpeed_read = w_val;
	axis_scan_data.sp_ac_dc.speed = *attr_ScanSpeed_read;
	
	/*----- PROTECTED REGION END -----*/	//	AxisG2Scan::write_ScanSpeed
}
//--------------------------------------------------------
/**
 *	Read attribute ScanAcceleration related method
 *	Description: 
 *
 *	Data type:	Tango::DevDouble
 *	Attr type:	Scalar
 */
//--------------------------------------------------------
void AxisG2Scan::read_ScanAcceleration(Tango::Attribute &attr)
{
	DEBUG_STREAM << "AxisG2Scan::read_ScanAcceleration(Tango::Attribute &attr) entering... " << endl;
	/*----- PROTECTED REGION ID(AxisG2Scan::read_ScanAcceleration) ENABLED START -----*/
	//	Set the attribute value
	attr.set_value(attr_ScanAcceleration_read);
	
	/*----- PROTECTED REGION END -----*/	//	AxisG2Scan::read_ScanAcceleration
}
//--------------------------------------------------------
/**
 *	Write attribute ScanAcceleration related method
 *	Description: 
 *
 *	Data type:	Tango::DevDouble
 *	Attr type:	Scalar
 */
//--------------------------------------------------------
void AxisG2Scan::write_ScanAcceleration(Tango::WAttribute &attr)
{
	DEBUG_STREAM << "AxisG2Scan::write_ScanAcceleration(Tango::WAttribute &attr) entering... " << endl;
	//	Retrieve write value
	Tango::DevDouble	w_val;
	attr.get_write_value(w_val);
	/*----- PROTECTED REGION ID(AxisG2Scan::write_ScanAcceleration) ENABLED START -----*/
	
	*attr_ScanAcceleration_read = w_val;
	axis_scan_data.sp_ac_dc.accel = *attr_ScanAcceleration_read;
	
	/*----- PROTECTED REGION END -----*/	//	AxisG2Scan::write_ScanAcceleration
}
//--------------------------------------------------------
/**
 *	Read attribute ScanDeceleration related method
 *	Description: 
 *
 *	Data type:	Tango::DevDouble
 *	Attr type:	Scalar
 */
//--------------------------------------------------------
void AxisG2Scan::read_ScanDeceleration(Tango::Attribute &attr)
{
	DEBUG_STREAM << "AxisG2Scan::read_ScanDeceleration(Tango::Attribute &attr) entering... " << endl;
	/*----- PROTECTED REGION ID(AxisG2Scan::read_ScanDeceleration) ENABLED START -----*/
	//	Set the attribute value
	attr.set_value(attr_ScanDeceleration_read);
	
	/*----- PROTECTED REGION END -----*/	//	AxisG2Scan::read_ScanDeceleration
}
//--------------------------------------------------------
/**
 *	Write attribute ScanDeceleration related method
 *	Description: 
 *
 *	Data type:	Tango::DevDouble
 *	Attr type:	Scalar
 */
//--------------------------------------------------------
void AxisG2Scan::write_ScanDeceleration(Tango::WAttribute &attr)
{
	DEBUG_STREAM << "AxisG2Scan::write_ScanDeceleration(Tango::WAttribute &attr) entering... " << endl;
	//	Retrieve write value
	Tango::DevDouble	w_val;
	attr.get_write_value(w_val);
	/*----- PROTECTED REGION ID(AxisG2Scan::write_ScanDeceleration) ENABLED START -----*/
	
	*attr_ScanDeceleration_read= w_val;
	axis_scan_data.sp_ac_dc.decel = *attr_ScanDeceleration_read;
	
	/*----- PROTECTED REGION END -----*/	//	AxisG2Scan::write_ScanDeceleration
}
//--------------------------------------------------------
/**
 *	Read attribute ScanFSM related method
 *	Description: 
 *
 *	Data type:	Tango::DevString
 *	Attr type:	Scalar
 */
//--------------------------------------------------------
void AxisG2Scan::read_ScanFSM(Tango::Attribute &attr)
{
	DEBUG_STREAM << "AxisG2Scan::read_ScanFSM(Tango::Attribute &attr) entering... " << endl;
	/*----- PROTECTED REGION ID(AxisG2Scan::read_ScanFSM) ENABLED START -----*/


	retfsm = scanfsm->fsm(FSM_ns::FSMT_NOP);

	CORBA::string_free(*attr_ScanFSM_read);
        *attr_ScanFSM_read = Tango::string_dup(scanfsm->fsm_status().c_str());

	//	Set the attribute value
	attr.set_value(attr_ScanFSM_read);
	
	/*----- PROTECTED REGION END -----*/	//	AxisG2Scan::read_ScanFSM
}
//--------------------------------------------------------
/**
 *	Read attribute ScanBeginBN related method
 *	Description: 
 *
 *	Data type:	Tango::DevLong
 *	Attr type:	Scalar
 */
//--------------------------------------------------------
void AxisG2Scan::read_ScanBeginBN(Tango::Attribute &attr)
{
	DEBUG_STREAM << "AxisG2Scan::read_ScanBeginBN(Tango::Attribute &attr) entering... " << endl;
	/*----- PROTECTED REGION ID(AxisG2Scan::read_ScanBeginBN) ENABLED START -----*/
	//	Set the attribute value
	attr.set_value(attr_ScanBeginBN_read);
	
	/*----- PROTECTED REGION END -----*/	//	AxisG2Scan::read_ScanBeginBN
}
//--------------------------------------------------------
/**
 *	Read attribute ScanEndBN related method
 *	Description: 
 *
 *	Data type:	Tango::DevLong
 *	Attr type:	Scalar
 */
//--------------------------------------------------------
void AxisG2Scan::read_ScanEndBN(Tango::Attribute &attr)
{
	DEBUG_STREAM << "AxisG2Scan::read_ScanEndBN(Tango::Attribute &attr) entering... " << endl;
	/*----- PROTECTED REGION ID(AxisG2Scan::read_ScanEndBN) ENABLED START -----*/
	//	Set the attribute value
	attr.set_value(attr_ScanEndBN_read);
	
	/*----- PROTECTED REGION END -----*/	//	AxisG2Scan::read_ScanEndBN
}
//--------------------------------------------------------
/**
 *	Read attribute Position related method
 *	Description: 
 *
 *	Data type:	Tango::DevDouble
 *	Attr type:	Scalar
 */
//--------------------------------------------------------
void AxisG2Scan::read_Position(Tango::Attribute &attr)
{
	DEBUG_STREAM << "AxisG2Scan::read_Position(Tango::Attribute &attr) entering... " << endl;
	/*----- PROTECTED REGION ID(AxisG2Scan::read_Position) ENABLED START -----*/

	*attr_Position_read = get_axis_position();
	//	Set the attribute value
	attr.set_value(attr_Position_read);
	
	/*----- PROTECTED REGION END -----*/	//	AxisG2Scan::read_Position
}
//--------------------------------------------------------
/**
 *	Read attribute ScanTotalTime related method
 *	Description: 
 *
 *	Data type:	Tango::DevDouble
 *	Attr type:	Scalar
 */
//--------------------------------------------------------
void AxisG2Scan::read_ScanTotalTime(Tango::Attribute &attr)
{
	DEBUG_STREAM << "AxisG2Scan::read_ScanTotalTime(Tango::Attribute &attr) entering... " << endl;
	/*----- PROTECTED REGION ID(AxisG2Scan::read_ScanTotalTime) ENABLED START -----*/

	*attr_ScanTotalTime_read = scanfsm->get_scan_total_time();
	//	Set the attribute value
	attr.set_value(attr_ScanTotalTime_read);
	
	/*----- PROTECTED REGION END -----*/	//	AxisG2Scan::read_ScanTotalTime
}
//--------------------------------------------------------
/**
 *	Read attribute ExtStatus related method
 *	Description: 
 *
 *	Data type:	Tango::DevString
 *	Attr type:	Spectrum max = 100
 */
//--------------------------------------------------------
void AxisG2Scan::read_ExtStatus(Tango::Attribute &attr)
{
	DEBUG_STREAM << "AxisG2Scan::read_ExtStatus(Tango::Attribute &attr) entering... " << endl;
	/*----- PROTECTED REGION ID(AxisG2Scan::read_ExtStatus) ENABLED START -----*/

      	// MYCODE-START
        //AASS
        std::stringstream ss;

        int riga = 0;
        int howmany = 0;

        ss.str("");
	//========================
        ss << "axisDevice        = " << axisDevice;
        ExtStatus(attr_ExtStatus_read, &riga, ss.str());
        howmany++;

        ss.str("");
	//========================
        ss << "axisDriver        = " << axis_driver;
        ExtStatus(attr_ExtStatus_read, &riga, ss.str());
        howmany++;

        ss.str("");
	//========================
        ss << "axisChannel       = " << axis_channel;
        ExtStatus(attr_ExtStatus_read, &riga, ss.str());
        howmany++;

        ss.str("");
	//========================
        ss << "axis per          = " << per;
        ExtStatus(attr_ExtStatus_read, &riga, ss.str());
        howmany++;

        ss.str("");
	//========================
        ss << "axis peo          = " << peo;
        ExtStatus(attr_ExtStatus_read, &riga, ss.str());
        howmany++;

        ss.str("");
	//========================
        ss << "axisBufferDevice  = " << axisBufferDevice;
        ExtStatus(attr_ExtStatus_read, &riga, ss.str());
        howmany++;

        ss.str("");
	//========================
        ss << "axisPollOff       = " << (axisPollOff?"true":"false");
        ExtStatus(attr_ExtStatus_read, &riga, ss.str());
        howmany++;

        ss.str("");
	//========================
        ExtStatus(attr_ExtStatus_read, &riga, ss.str());
        howmany++;

        ss.str("");
	//========================
	ss << "FSM trace error: " << scanfsm->get_trace_err();
        ExtStatus(attr_ExtStatus_read, &riga, ss.str());
        howmany++;

        ss.str("");
	//========================
        ExtStatus(attr_ExtStatus_read, &riga, ss.str());
        howmany++;

        ss.str("");
	//========================
	ss << "------------  axis_driver polling at DevInit  -----------------";
        ExtStatus(attr_ExtStatus_read, &riga, ss.str());
        howmany++;

	vector<attrpoll_t>::iterator apit;
	for (apit=drv_attrpoll.begin(); apit!=drv_attrpoll.end(); ++apit){
        	ss.str(""),
		ss << "attr, pollperiod : " << (*apit).attr << "," << (*apit).poll_period;
	
        	ExtStatus(attr_ExtStatus_read, &riga, ss.str());
        	howmany++;
	}

        ss.str("");
	//========================
	ss << "------------  axis_driver polling at PRESENT -----------------";
        ExtStatus(attr_ExtStatus_read, &riga, ss.str());
        howmany++;

        ss.str("");
	//========================
	struct timeval deltaTime, nowTime;
	gettimeofday(&nowTime, NULL);
	timersub(&nowTime, &extStatus_lastAcq_time, &deltaTime);

	int deltaTime_sec = (int)((((float)deltaTime.tv_sec)*1000000.0 + (float)deltaTime.tv_usec)/1000000);

#if 0
	cout << "deltaTime.tv_sec = " << deltaTime.tv_sec << endl;
	cout << "nowTime.tv_sec = " << nowTime.tv_sec << endl;
	cout << "extStatus_lastAcq_time.tv_sec = " << extStatus_lastAcq_time.tv_sec << endl;
	cout << "deltaTime_sec = " << deltaTime_sec << endl;
#endif

	if (deltaTime_sec > 10){
		stringstream lss("");
		ss << "Update!";
        	ExtStatus(attr_ExtStatus_read, &riga, ss.str());
        	howmany++;

		extStatus_lastAcq_save.erase (extStatus_lastAcq_save.begin(),extStatus_lastAcq_save.end());

		extStatus_lastAcq_time = nowTime;


		//
		//	------ Otteniamo i tempi di polling per axis_driver ------
		//
		//
		vector<string> *att_list = NULL;	
		try {
			att_list = drv_dp->get_attribute_list();	
	
			vector<string>::iterator it;
			int poll_period = -1;
	
			for (it = att_list->begin(); it != att_list->end(); ++it){
				poll_period = -1;
				if (drv_dp->is_attribute_polled(*it)){
					poll_period = drv_dp->get_attribute_poll_period(*it);
					lss.str("");
					lss << "attr, pollperiod : " << *it << "," << poll_period;
					extStatus_lastAcq_save.push_back(lss.str());
				}
			}
			
		} catch (...) {
			ss << (" : exception on Tango::DeviceProxy(" + axisDevice + ")!");
		}
		if (att_list) {
			delete att_list;
			att_list = NULL;
		}


        	lss.str("");
		//========================
		lss << "------------  axis_driver polling DbHistory -----------------";
		extStatus_lastAcq_save.push_back(lss.str());

		vector<Tango::DbHistory> hist;
		Tango::DbDatum result;
		string propname("polled_attr");
		vector<string> vs;

		#ifdef __KEN__
			string th(TH);
			th += "sys/database/2";
			Tango::DeviceProxy db_dev = Tango::DeviceProxy(th);

			//cout << dv_dev.command
		#else
	        	Tango::Util *tg = Tango::Util::instance();
        		Tango::Database *db = tg->get_database();
			//cout << db->get_dbase()->name() << endl;

			//cout << "get_device_property_history(" << axis_driver << "," << propname << ")" << endl;
			hist = db->get_device_property_history(axis_driver, propname) ;		

			//cout << "hist.size() = " << hist.size() << endl;

			for(unsigned int i=0;i<hist.size();i++) {
        			lss.str("");
   				//cout << "Name:" << hist[i].get_name() << " ";
   				//cout << "Date:" << hist[i].get_date() << " ";
   				if( hist[i].is_deleted() ) {
       					//cout << "Deleted !" << endl;;
   				} else {
					lss << hist[i].get_date() << " ";
       					hist[i].get_value() >> vs;
       					for (unsigned int j=0; j<vs.size(); j++) {
          					//cout << "Value:" << vs[j] << " ";
						lss << vs[j] << " ";
					}
					extStatus_lastAcq_save.push_back(lss.str());
					//cout << endl;
   				}
			}

        		lss.str("");
			//========================
			lss << "------------  axisDevice value DbHistory -----------------";
			extStatus_lastAcq_save.push_back(lss.str());

			string attrpropname("__value");
			string attrname("");

			attrname = "Speed";
			//cout << axisDevice << " " << attrname << " " << attrpropname << endl;
			hist = db->get_device_attribute_property_history(axisDevice, attrname, attrpropname) ;		
			for(unsigned int i=0;i<hist.size();i++) {
        			lss.str("");
   				//cout << "Name:" << hist[i].get_name() << " ";
   				//cout << "Date:" << hist[i].get_date() << " ";
   				if( hist[i].is_deleted() ) {
       					//cout << "Deleted !" << endl;;
   				} else {
					lss << hist[i].get_date() << " ";
					lss << hist[i].get_name() << " ";
       					hist[i].get_value() >> vs;
       					for (unsigned int j=0; j<vs.size(); j++) {
          					//cout << "Value:" << vs[j] << " ";
						lss << vs[j] << " ";
					}
					extStatus_lastAcq_save.push_back(lss.str());
					//cout << endl;
   				}
			}
		#endif


	} else {
		ss << "Next update in " << (10 - deltaTime_sec + 1) << " sec...";
        	ExtStatus(attr_ExtStatus_read, &riga, ss.str());
        	howmany++;
	}
	vector<string>::iterator sit;
	for (sit = extStatus_lastAcq_save.begin(); sit != extStatus_lastAcq_save.end(); ++sit){
       		ExtStatus(attr_ExtStatus_read, &riga, *sit);
       		howmany++;
	}


       	//      Set the attribute value
        if ( howmany > 100 ) howmany = 100;
        attr.set_value(attr_ExtStatus_read, howmany);


        // MYCODE-END
	
	/*----- PROTECTED REGION END -----*/	//	AxisG2Scan::read_ExtStatus
}
//--------------------------------------------------------
/**
 *	Read attribute ScanPositions related method
 *	Description: 
 *
 *	Data type:	Tango::DevDouble
 *	Attr type:	Spectrum max = 10000
 */
//--------------------------------------------------------
void AxisG2Scan::read_ScanPositions(Tango::Attribute &attr)
{
	DEBUG_STREAM << "AxisG2Scan::read_ScanPositions(Tango::Attribute &attr) entering... " << endl;
	/*----- PROTECTED REGION ID(AxisG2Scan::read_ScanPositions) ENABLED START -----*/

	int tocopy = 0;

	if (vd.size() > 0 ){
        	if (vd.size() <= 10000) {
			tocopy = vd.size();
        	} else {
			tocopy = 10000;
		}
		for (int k = 0; k < tocopy; k++){
			attr_ScanPositions_read[k] = per * (double)vd[k] + peo;

			#ifdef _DBG_SCANPOSITIONS
				if (vd.size() > 10000){
					cout << (double)vd[k] << " " ;
				}
				cout << endl;
			#endif /* _DBG_SCANPOSITIONS */
		}
	}
	

	#ifdef _DBG_SCANPOSITIONS
        	cout << "vd.size() = " << vd.size() << " tocopy = " << tocopy << endl;
	#endif /* _DBG_SCANPOSITIONS */

	//	Set the attribute value
	attr.set_value(attr_ScanPositions_read, tocopy);
	
	/*----- PROTECTED REGION END -----*/	//	AxisG2Scan::read_ScanPositions
}
//--------------------------------------------------------
/**
 *	Read attribute ScanBN related method
 *	Description: 
 *
 *	Data type:	Tango::DevLong
 *	Attr type:	Spectrum max = 10000
 */
//--------------------------------------------------------
void AxisG2Scan::read_ScanBN(Tango::Attribute &attr)
{
	DEBUG_STREAM << "AxisG2Scan::read_ScanBN(Tango::Attribute &attr) entering... " << endl;
	/*----- PROTECTED REGION ID(AxisG2Scan::read_ScanBN) ENABLED START -----*/

	int tocopy = 0;

	if (bn.size() > 0 ){
        	if (bn.size() <= 10000) {
			tocopy = bn.size();
        	} else {
			tocopy = 10000;
		}
		for (int k = 0; k < tocopy; k++){
			attr_ScanBN_read[k] = bn[k];

			#ifdef _DBG_SCANPOSITIONS
				if (bn.size() > 10000){
					cout << bn[k] << " " ;
				}
				cout << endl;
			#endif /* _DBG_SCANPOSITIONS */
		}
	}
	

	#ifdef _DBG_SCANPOSITIONS
        	cout << "bn.size() = " << bn.size() << " tocopy = " << tocopy << endl;
	#endif /* _DBG_SCANPOSITIONS */

	//	Set the attribute value
	attr.set_value(attr_ScanBN_read, tocopy);
	
	/*----- PROTECTED REGION END -----*/	//	AxisG2Scan::read_ScanBN
}

//--------------------------------------------------------
/**
 *	Method      : AxisG2Scan::add_dynamic_attributes()
 *	Description : Create the dynamic attributes if any
 *                for specified device.
 */
//--------------------------------------------------------
void AxisG2Scan::add_dynamic_attributes()
{
	/*----- PROTECTED REGION ID(AxisG2Scan::add_dynamic_attributes) ENABLED START -----*/
	
	//	Add your own code to create and add dynamic attributes if any
	
	/*----- PROTECTED REGION END -----*/	//	AxisG2Scan::add_dynamic_attributes
}

//--------------------------------------------------------
/**
 *	Command Start related method
 *	Description: Start the scan
 *
 */
//--------------------------------------------------------
void AxisG2Scan::start()
{
	DEBUG_STREAM << "AxisG2Scan::Start()  - " << device_name << endl;
	/*----- PROTECTED REGION ID(AxisG2Scan::start) ENABLED START -----*/
	
	//	Add your own code

        // MYCODE-START

	*attr_ScanBeginBN_read = -1;
	*attr_ScanEndBN_read = -1;
	axis_actual_scan_data = axis_scan_data;

	retfsm = scanfsm->fsm(FSM_ns::FSMT_START);

        // MYCODE-END
	
	/*----- PROTECTED REGION END -----*/	//	AxisG2Scan::start
}
//--------------------------------------------------------
/**
 *	Command Stop related method
 *	Description: Stop the scan
 *
 */
//--------------------------------------------------------
void AxisG2Scan::stop()
{
	DEBUG_STREAM << "AxisG2Scan::Stop()  - " << device_name << endl;
	/*----- PROTECTED REGION ID(AxisG2Scan::stop) ENABLED START -----*/
	
	//	Add your own code

        // MYCODE-START

	try {
		axis_dp->command_inout("Stop");
	} catch (...) {
		cout << "error on stop()" << endl;
	}
	retfsm = scanfsm->fsm(FSM_ns::FSMT_STOP);

	*attr_ScanBeginBN_read = -1;
	*attr_ScanEndBN_read = -1;

	vd.clear(); 
	bn.clear();

        // MYCODE-END
	
	/*----- PROTECTED REGION END -----*/	//	AxisG2Scan::stop
}
//--------------------------------------------------------
/**
 *	Command RevStart related method
 *	Description: Start the scan in reverse mode
 *
 */
//--------------------------------------------------------
void AxisG2Scan::rev_start()
{
	DEBUG_STREAM << "AxisG2Scan::RevStart()  - " << device_name << endl;
	/*----- PROTECTED REGION ID(AxisG2Scan::rev_start) ENABLED START -----*/
	
	//	Add your own code

        // MYCODE-START

	*attr_ScanBeginBN_read = -1;
	*attr_ScanEndBN_read = -1;
/*
typedef struct {
        sp_ac_dc_t sp_ac_dc;
        double begin;
        double end;
} scan_t;
*/
	axis_actual_scan_data.begin = axis_scan_data.end;
	axis_actual_scan_data.end = axis_scan_data.begin;
	axis_actual_scan_data.sp_ac_dc = axis_scan_data.sp_ac_dc;

	retfsm = scanfsm->fsm(FSM_ns::FSMT_START);

        // MYCODE-END
	
	/*----- PROTECTED REGION END -----*/	//	AxisG2Scan::rev_start
}
//--------------------------------------------------------
/**
 *	Method      : AxisG2Scan::add_dynamic_commands()
 *	Description : Create the dynamic commands if any
 *                for specified device.
 */
//--------------------------------------------------------
void AxisG2Scan::add_dynamic_commands()
{
	/*----- PROTECTED REGION ID(AxisG2Scan::add_dynamic_commands) ENABLED START -----*/
	
	//	Add your own code to create and add dynamic commands if any
	
	/*----- PROTECTED REGION END -----*/	//	AxisG2Scan::add_dynamic_commands
}

/*----- PROTECTED REGION ID(AxisG2Scan::namespace_ending) ENABLED START -----*/

//	Additional Methods

/*----- PROTECTED REGION END -----*/	//	AxisG2Scan::namespace_ending
} //	namespace
