/*----- PROTECTED REGION ID(AxisG2Scan.h) ENABLED START -----*/
//=============================================================================
//
// file :        AxisG2Scan.h
//
// description : Include file for the AxisG2Scan class
//
// project :     
//
// This file is part of Tango device class.
// 
// Tango is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
// 
// Tango is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// 
// You should have received a copy of the GNU General Public License
// along with Tango.  If not, see <http://www.gnu.org/licenses/>.
// 
//
//
//=============================================================================
//                This file is generated by POGO
//        (Program Obviously used to Generate tango Object)
//=============================================================================


#ifndef AxisG2Scan_H
#define AxisG2Scan_H

#include <tango.h>
#include "AxisG2ScanErrors.h"
#include "AxisG2ScanTypes.h"


#include "FSMTypes.h"
namespace FSM_ns { class FSM; }


/*----- PROTECTED REGION END -----*/	//	AxisG2Scan.h

/**
 *  AxisG2Scan class description:
 *    
 */

namespace AxisG2Scan_ns
{
/*----- PROTECTED REGION ID(AxisG2Scan::Additional Class Declarations) ENABLED START -----*/

//	Additional Class Declarations

/*----- PROTECTED REGION END -----*/	//	AxisG2Scan::Additional Class Declarations

class AxisG2Scan : public TANGO_BASE_CLASS
{

/*----- PROTECTED REGION ID(AxisG2Scan::Data Members) ENABLED START -----*/

//	Add your own data members

	Tango::DeviceProxy *axis_dp;
	string axis_driver;
	string axis_channel;

	int channel_no;

	double per;
	double peo;

	Tango::DeviceProxy *drv_dp;

	Tango::DeviceProxy *axisBuffer_dp;

	vector<attrpoll_t> axis_attrpoll;
	vector<attrpoll_t> drv_attrpoll;

	sp_ac_dc_t axis_default_data;
	scan_t axis_scan_data;
	scan_t axis_actual_scan_data;

	int max_axisDevice_poll_time;

	FSM_ns::FSM *scanfsm;
	FSM_ns::FSM_t retfsm;
	vector<long> vd;
	vector<long> bn;

	struct timeval extStatus_lastAcq_time;
	vector<string> extStatus_lastAcq_save;


/*----- PROTECTED REGION END -----*/	//	AxisG2Scan::Data Members

//	Device property data members
public:
	//	AxisDevice:	
	string	axisDevice;
	//	AxisBufferDevice:	
	string	axisBufferDevice;
	//	AxisPollOff:	if true disable polling in YAMS during scan
	Tango::DevBoolean	axisPollOff;

	bool	mandatoryNotDefined;

//	Attribute data members
public:
	Tango::DevDouble	*attr_ScanBegin_read;
	Tango::DevDouble	*attr_ScanEnd_read;
	Tango::DevDouble	*attr_ScanSpeed_read;
	Tango::DevDouble	*attr_ScanAcceleration_read;
	Tango::DevDouble	*attr_ScanDeceleration_read;
	Tango::DevString	*attr_ScanFSM_read;
	Tango::DevLong	*attr_ScanBeginBN_read;
	Tango::DevLong	*attr_ScanEndBN_read;
	Tango::DevDouble	*attr_Position_read;
	Tango::DevDouble	*attr_ScanTotalTime_read;
	Tango::DevString	*attr_ExtStatus_read;
	Tango::DevDouble	*attr_ScanPositions_read;
	Tango::DevLong	*attr_ScanBN_read;

//	Constructors and destructors
public:
	/**
	 * Constructs a newly device object.
	 *
	 *	@param cl	Class.
	 *	@param s 	Device Name
	 */
	AxisG2Scan(Tango::DeviceClass *cl,string &s);
	/**
	 * Constructs a newly device object.
	 *
	 *	@param cl	Class.
	 *	@param s 	Device Name
	 */
	AxisG2Scan(Tango::DeviceClass *cl,const char *s);
	/**
	 * Constructs a newly device object.
	 *
	 *	@param cl	Class.
	 *	@param s 	Device name
	 *	@param d	Device description.
	 */
	AxisG2Scan(Tango::DeviceClass *cl,const char *s,const char *d);
	/**
	 * The device object destructor.
	 */
	~AxisG2Scan() {delete_device();};


//	Miscellaneous methods
public:
	/*
	 *	will be called at device destruction or at init command.
	 */
	void delete_device();
	/*
	 *	Initialize the device
	 */
	virtual void init_device();
	/*
	 *	Read the device properties from database
	 */
	void get_device_property();
	/*
	 *	Always executed method before execution command method.
	 */
	virtual void always_executed_hook();

	/*
	 *	Check if mandatory property has been set
	 */
	 void check_mandatory_property(Tango::DbDatum &class_prop, Tango::DbDatum &dev_prop);

//	Attribute methods
public:
	//--------------------------------------------------------
	/*
	 *	Method      : AxisG2Scan::read_attr_hardware()
	 *	Description : Hardware acquisition for attributes.
	 */
	//--------------------------------------------------------
	virtual void read_attr_hardware(vector<long> &attr_list);
	//--------------------------------------------------------
	/*
	 *	Method      : AxisG2Scan::write_attr_hardware()
	 *	Description : Hardware writing for attributes.
	 */
	//--------------------------------------------------------
	virtual void write_attr_hardware(vector<long> &attr_list);

/**
 *	Attribute ScanBegin related methods
 *	Description: 
 *
 *	Data type:	Tango::DevDouble
 *	Attr type:	Scalar
 */
	virtual void read_ScanBegin(Tango::Attribute &attr);
	virtual void write_ScanBegin(Tango::WAttribute &attr);
	virtual bool is_ScanBegin_allowed(Tango::AttReqType type);
/**
 *	Attribute ScanEnd related methods
 *	Description: 
 *
 *	Data type:	Tango::DevDouble
 *	Attr type:	Scalar
 */
	virtual void read_ScanEnd(Tango::Attribute &attr);
	virtual void write_ScanEnd(Tango::WAttribute &attr);
	virtual bool is_ScanEnd_allowed(Tango::AttReqType type);
/**
 *	Attribute ScanSpeed related methods
 *	Description: 
 *
 *	Data type:	Tango::DevDouble
 *	Attr type:	Scalar
 */
	virtual void read_ScanSpeed(Tango::Attribute &attr);
	virtual void write_ScanSpeed(Tango::WAttribute &attr);
	virtual bool is_ScanSpeed_allowed(Tango::AttReqType type);
/**
 *	Attribute ScanAcceleration related methods
 *	Description: 
 *
 *	Data type:	Tango::DevDouble
 *	Attr type:	Scalar
 */
	virtual void read_ScanAcceleration(Tango::Attribute &attr);
	virtual void write_ScanAcceleration(Tango::WAttribute &attr);
	virtual bool is_ScanAcceleration_allowed(Tango::AttReqType type);
/**
 *	Attribute ScanDeceleration related methods
 *	Description: 
 *
 *	Data type:	Tango::DevDouble
 *	Attr type:	Scalar
 */
	virtual void read_ScanDeceleration(Tango::Attribute &attr);
	virtual void write_ScanDeceleration(Tango::WAttribute &attr);
	virtual bool is_ScanDeceleration_allowed(Tango::AttReqType type);
/**
 *	Attribute ScanFSM related methods
 *	Description: 
 *
 *	Data type:	Tango::DevString
 *	Attr type:	Scalar
 */
	virtual void read_ScanFSM(Tango::Attribute &attr);
	virtual bool is_ScanFSM_allowed(Tango::AttReqType type);
/**
 *	Attribute ScanBeginBN related methods
 *	Description: 
 *
 *	Data type:	Tango::DevLong
 *	Attr type:	Scalar
 */
	virtual void read_ScanBeginBN(Tango::Attribute &attr);
	virtual bool is_ScanBeginBN_allowed(Tango::AttReqType type);
/**
 *	Attribute ScanEndBN related methods
 *	Description: 
 *
 *	Data type:	Tango::DevLong
 *	Attr type:	Scalar
 */
	virtual void read_ScanEndBN(Tango::Attribute &attr);
	virtual bool is_ScanEndBN_allowed(Tango::AttReqType type);
/**
 *	Attribute Position related methods
 *	Description: 
 *
 *	Data type:	Tango::DevDouble
 *	Attr type:	Scalar
 */
	virtual void read_Position(Tango::Attribute &attr);
	virtual bool is_Position_allowed(Tango::AttReqType type);
/**
 *	Attribute ScanTotalTime related methods
 *	Description: 
 *
 *	Data type:	Tango::DevDouble
 *	Attr type:	Scalar
 */
	virtual void read_ScanTotalTime(Tango::Attribute &attr);
	virtual bool is_ScanTotalTime_allowed(Tango::AttReqType type);
/**
 *	Attribute ExtStatus related methods
 *	Description: 
 *
 *	Data type:	Tango::DevString
 *	Attr type:	Spectrum max = 100
 */
	virtual void read_ExtStatus(Tango::Attribute &attr);
	virtual bool is_ExtStatus_allowed(Tango::AttReqType type);
/**
 *	Attribute ScanPositions related methods
 *	Description: 
 *
 *	Data type:	Tango::DevDouble
 *	Attr type:	Spectrum max = 10000
 */
	virtual void read_ScanPositions(Tango::Attribute &attr);
	virtual bool is_ScanPositions_allowed(Tango::AttReqType type);
/**
 *	Attribute ScanBN related methods
 *	Description: 
 *
 *	Data type:	Tango::DevLong
 *	Attr type:	Spectrum max = 10000
 */
	virtual void read_ScanBN(Tango::Attribute &attr);
	virtual bool is_ScanBN_allowed(Tango::AttReqType type);


	//--------------------------------------------------------
	/**
	 *	Method      : AxisG2Scan::add_dynamic_attributes()
	 *	Description : Add dynamic attributes if any.
	 */
	//--------------------------------------------------------
	void add_dynamic_attributes();




//	Command related methods
public:
	/**
	 *	Command Start related method
	 *	Description: Start the scan
	 *
	 */
	virtual void start();
	virtual bool is_Start_allowed(const CORBA::Any &any);
	/**
	 *	Command Stop related method
	 *	Description: Stop the scan
	 *
	 */
	virtual void stop();
	virtual bool is_Stop_allowed(const CORBA::Any &any);
	/**
	 *	Command RevStart related method
	 *	Description: Start the scan in reverse mode
	 *
	 */
	virtual void rev_start();
	virtual bool is_RevStart_allowed(const CORBA::Any &any);


	//--------------------------------------------------------
	/**
	 *	Method      : AxisG2Scan::add_dynamic_commands()
	 *	Description : Add dynamic commands if any.
	 */
	//--------------------------------------------------------
	void add_dynamic_commands();

/*----- PROTECTED REGION ID(AxisG2Scan::Additional Method prototypes) ENABLED START -----*/

//	Additional Method prototypes

	sp_ac_dc_t 	getspacdc(string &msg);
	void 		refresh_spacdc(string &msg)	{ axis_default_data = getspacdc(msg); };

	sp_ac_dc_t 	get_axis_default_data()             {return axis_default_data;};
	void       	set_axis_default_data(sp_ac_dc_t v) {axis_default_data = v;};

	scan_t 		get_axis_scan_data()	   	{ return axis_scan_data;};
	void   		set_axis_scan_data(scan_t v)	{ axis_scan_data = v;};

	scan_t 		get_axis_actual_scan_data()	   	{ return axis_actual_scan_data;};
	void   		set_axis_actual_scan_data(scan_t v)	{ axis_actual_scan_data = v;};

	Tango::DeviceProxy *get_axis_dp()  	{ return axis_dp; };
	Tango::DeviceProxy *get_drv_dp()   	{ return drv_dp; };
	Tango::DeviceProxy *get_axisBuffer_dp()	{ return axisBuffer_dp; };

	void 		set_attr_ScanBeginBN(long v)  	{ *attr_ScanBeginBN_read = v; return; };
	Tango::DevLong 	get_attr_ScanBeginBN()  	{ return *attr_ScanBeginBN_read; };
	void 		set_attr_ScanEndBN(long v)  	{ *attr_ScanEndBN_read = v; return; };
	Tango::DevLong 	get_attr_ScanEndBN()  	{ return *attr_ScanEndBN_read; };

	void 		ExtStatus(Tango::DevString *extstatusattr, int *riga, string msg);

	void 		set_attr_ScanPositions(Tango::DeviceData dd)	{dd >> vd;};
	void 		set_attr_ScanBN(Tango::DeviceData dd)		{dd >> bn;};
	void 		set_attr_ScanPositionsBN(Tango::DeviceData dd);

	int 		get_channel_no()	{ return channel_no; };

	Tango::DevState get_axis_state();
	double 		get_axis_position();
	double 		get_axis_position(FSM_ns::FSM_t _retfsm);


	bool 		get_axisPollOff()	{ return axisPollOff; };
	bool 		drv_attrpoll_off(int long_poll);
	bool 		drv_attrpoll_on();
        int 		get_ScanFSMPollPeriod() 	{ return get_attribute_poll_period("ScanFSM");};

	int 		get_max_axisDevice_poll_time() { return max_axisDevice_poll_time; };

	#if 0
	bool refresh();
	#endif



/*----- PROTECTED REGION END -----*/	//	AxisG2Scan::Additional Method prototypes
};

/*----- PROTECTED REGION ID(AxisG2Scan::Additional Classes Definitions) ENABLED START -----*/

//	Additional Classes Definitions

/*----- PROTECTED REGION END -----*/	//	AxisG2Scan::Additional Classes Definitions

}	//	End of namespace

#endif   //	AxisG2Scan_H
