/*----- PROTECTED REGION ID(AxisG2ScanClass.cpp) ENABLED START -----*/
//=============================================================================
//
// file :        AxisG2ScanClass.cpp
//
// description : C++ source for the AxisG2ScanClass.
//               A singleton class derived from DeviceClass.
//               It implements the command and attribute list
//               and all properties and methods required
//               by the AxisG2Scan once per process.
//
// project :     
//
// This file is part of Tango device class.
// 
// Tango is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
// 
// Tango is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// 
// You should have received a copy of the GNU General Public License
// along with Tango.  If not, see <http://www.gnu.org/licenses/>.
// 
//
//
//=============================================================================
//                This file is generated by POGO
//        (Program Obviously used to Generate tango Object)
//=============================================================================


#include <AxisG2ScanClass.h>

/*----- PROTECTED REGION END -----*/	//	AxisG2ScanClass.cpp

//-------------------------------------------------------------------
/**
 *	Create AxisG2ScanClass singleton and
 *	return it in a C function for Python usage
 */
//-------------------------------------------------------------------
extern "C" {
#ifdef _TG_WINDOWS_

__declspec(dllexport)

#endif

	Tango::DeviceClass *_create_AxisG2Scan_class(const char *name) {
		return AxisG2Scan_ns::AxisG2ScanClass::init(name);
	}
}

namespace AxisG2Scan_ns
{
//===================================================================
//	Initialize pointer for singleton pattern
//===================================================================
AxisG2ScanClass *AxisG2ScanClass::_instance = NULL;

//--------------------------------------------------------
/**
 * method : 		AxisG2ScanClass::AxisG2ScanClass(string &s)
 * description : 	constructor for the AxisG2ScanClass
 *
 * @param s	The class name
 */
//--------------------------------------------------------
AxisG2ScanClass::AxisG2ScanClass(string &s):Tango::DeviceClass(s)
{
	cout2 << "Entering AxisG2ScanClass constructor" << endl;
	set_default_property();
	write_class_property();

	/*----- PROTECTED REGION ID(AxisG2ScanClass::constructor) ENABLED START -----*/

        // version tag

        string Release(RELEASE);
        set_cvs_tag(Release);

        string Repository(REPO);
        set_cvs_location(Repository);

        doc_url = REPO;
	
	/*----- PROTECTED REGION END -----*/	//	AxisG2ScanClass::constructor

	cout2 << "Leaving AxisG2ScanClass constructor" << endl;
}

//--------------------------------------------------------
/**
 * method : 		AxisG2ScanClass::~AxisG2ScanClass()
 * description : 	destructor for the AxisG2ScanClass
 */
//--------------------------------------------------------
AxisG2ScanClass::~AxisG2ScanClass()
{
	/*----- PROTECTED REGION ID(AxisG2ScanClass::destructor) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	AxisG2ScanClass::destructor

	_instance = NULL;
}


//--------------------------------------------------------
/**
 * method : 		AxisG2ScanClass::init
 * description : 	Create the object if not already done.
 *                  Otherwise, just return a pointer to the object
 *
 * @param	name	The class name
 */
//--------------------------------------------------------
AxisG2ScanClass *AxisG2ScanClass::init(const char *name)
{
	if (_instance == NULL)
	{
		try
		{
			string s(name);
			_instance = new AxisG2ScanClass(s);
		}
		catch (bad_alloc &)
		{
			throw;
		}
	}
	return _instance;
}

//--------------------------------------------------------
/**
 * method : 		AxisG2ScanClass::instance
 * description : 	Check if object already created,
 *                  and return a pointer to the object
 */
//--------------------------------------------------------
AxisG2ScanClass *AxisG2ScanClass::instance()
{
	if (_instance == NULL)
	{
		cerr << "Class is not initialised !!" << endl;
		exit(-1);
	}
	return _instance;
}



//===================================================================
//	Command execution method calls
//===================================================================
//--------------------------------------------------------
/**
 * method : 		StartClass::execute()
 * description : 	method to trigger the execution of the command.
 *
 * @param	device	The device on which the command must be executed
 * @param	in_any	The command input data
 *
 *	returns The command output data (packed in the Any object)
 */
//--------------------------------------------------------
CORBA::Any *StartClass::execute(Tango::DeviceImpl *device, TANGO_UNUSED(const CORBA::Any &in_any))
{
	cout2 << "StartClass::execute(): arrived" << endl;
	((static_cast<AxisG2Scan *>(device))->start());
	return new CORBA::Any();
}

//--------------------------------------------------------
/**
 * method : 		StopClass::execute()
 * description : 	method to trigger the execution of the command.
 *
 * @param	device	The device on which the command must be executed
 * @param	in_any	The command input data
 *
 *	returns The command output data (packed in the Any object)
 */
//--------------------------------------------------------
CORBA::Any *StopClass::execute(Tango::DeviceImpl *device, TANGO_UNUSED(const CORBA::Any &in_any))
{
	cout2 << "StopClass::execute(): arrived" << endl;
	((static_cast<AxisG2Scan *>(device))->stop());
	return new CORBA::Any();
}

//--------------------------------------------------------
/**
 * method : 		RevStartClass::execute()
 * description : 	method to trigger the execution of the command.
 *
 * @param	device	The device on which the command must be executed
 * @param	in_any	The command input data
 *
 *	returns The command output data (packed in the Any object)
 */
//--------------------------------------------------------
CORBA::Any *RevStartClass::execute(Tango::DeviceImpl *device, TANGO_UNUSED(const CORBA::Any &in_any))
{
	cout2 << "RevStartClass::execute(): arrived" << endl;
	((static_cast<AxisG2Scan *>(device))->rev_start());
	return new CORBA::Any();
}


//===================================================================
//	Properties management
//===================================================================
//--------------------------------------------------------
/**
 *	Method      : AxisG2ScanClass::get_class_property()
 *	Description : Get the class property for specified name.
 */
//--------------------------------------------------------
Tango::DbDatum AxisG2ScanClass::get_class_property(string &prop_name)
{
	for (unsigned int i=0 ; i<cl_prop.size() ; i++)
		if (cl_prop[i].name == prop_name)
			return cl_prop[i];
	//	if not found, returns  an empty DbDatum
	return Tango::DbDatum(prop_name);
}

//--------------------------------------------------------
/**
 *	Method      : AxisG2ScanClass::get_default_device_property()
 *	Description : Return the default value for device property.
 */
//--------------------------------------------------------
Tango::DbDatum AxisG2ScanClass::get_default_device_property(string &prop_name)
{
	for (unsigned int i=0 ; i<dev_def_prop.size() ; i++)
		if (dev_def_prop[i].name == prop_name)
			return dev_def_prop[i];
	//	if not found, return  an empty DbDatum
	return Tango::DbDatum(prop_name);
}

//--------------------------------------------------------
/**
 *	Method      : AxisG2ScanClass::get_default_class_property()
 *	Description : Return the default value for class property.
 */
//--------------------------------------------------------
Tango::DbDatum AxisG2ScanClass::get_default_class_property(string &prop_name)
{
	for (unsigned int i=0 ; i<cl_def_prop.size() ; i++)
		if (cl_def_prop[i].name == prop_name)
			return cl_def_prop[i];
	//	if not found, return  an empty DbDatum
	return Tango::DbDatum(prop_name);
}


//--------------------------------------------------------
/**
 *	Method      : AxisG2ScanClass::set_default_property()
 *	Description : Set default property (class and device) for wizard.
 *                For each property, add to wizard property name and description.
 *                If default value has been set, add it to wizard property and
 *                store it in a DbDatum.
 */
//--------------------------------------------------------
void AxisG2ScanClass::set_default_property()
{
	string	prop_name;
	string	prop_desc;
	string	prop_def;
	vector<string>	vect_data;

	//	Set Default Class Properties

	//	Set Default device Properties
	prop_name = "AxisDevice";
	prop_desc = "";
	prop_def  = "";
	vect_data.clear();
	if (prop_def.length()>0)
	{
		Tango::DbDatum	data(prop_name);
		data << vect_data ;
		dev_def_prop.push_back(data);
		add_wiz_dev_prop(prop_name, prop_desc,  prop_def);
	}
	else
		add_wiz_dev_prop(prop_name, prop_desc);
	prop_name = "AxisBufferDevice";
	prop_desc = "";
	prop_def  = "";
	vect_data.clear();
	if (prop_def.length()>0)
	{
		Tango::DbDatum	data(prop_name);
		data << vect_data ;
		dev_def_prop.push_back(data);
		add_wiz_dev_prop(prop_name, prop_desc,  prop_def);
	}
	else
		add_wiz_dev_prop(prop_name, prop_desc);
	prop_name = "AxisPollOff";
	prop_desc = "if true disable polling in YAMS during scan";
	prop_def  = "";
	vect_data.clear();
	if (prop_def.length()>0)
	{
		Tango::DbDatum	data(prop_name);
		data << vect_data ;
		dev_def_prop.push_back(data);
		add_wiz_dev_prop(prop_name, prop_desc,  prop_def);
	}
	else
		add_wiz_dev_prop(prop_name, prop_desc);
}

//--------------------------------------------------------
/**
 *	Method      : AxisG2ScanClass::write_class_property()
 *	Description : Set class description fields as property in database
 */
//--------------------------------------------------------
void AxisG2ScanClass::write_class_property()
{
	//	First time, check if database used
	if (Tango::Util::_UseDb == false)
		return;

	Tango::DbData	data;
	string	classname = get_name();
	string	header;
	string::size_type	start, end;

	//	Put title
	Tango::DbDatum	title("ProjectTitle");
	string	str_title("");
	title << str_title;
	data.push_back(title);

	//	Put Description
	Tango::DbDatum	description("Description");
	vector<string>	str_desc;
	str_desc.push_back("");
	description << str_desc;
	data.push_back(description);

	//  Put inheritance
	Tango::DbDatum	inher_datum("InheritedFrom");
	vector<string> inheritance;
	inheritance.push_back("TANGO_BASE_CLASS");
	inher_datum << inheritance;
	data.push_back(inher_datum);

	//	Call database and and values
	get_db_class()->put_property(data);
}

//===================================================================
//	Factory methods
//===================================================================

//--------------------------------------------------------
/**
 *	Method      : AxisG2ScanClass::device_factory()
 *	Description : Create the device object(s)
 *                and store them in the device list
 */
//--------------------------------------------------------
void AxisG2ScanClass::device_factory(const Tango::DevVarStringArray *devlist_ptr)
{
	/*----- PROTECTED REGION ID(AxisG2ScanClass::device_factory_before) ENABLED START -----*/
	
	//	Add your own code
	
	/*----- PROTECTED REGION END -----*/	//	AxisG2ScanClass::device_factory_before

	//	Create devices and add it into the device list
	for (unsigned long i=0 ; i<devlist_ptr->length() ; i++)
	{
		cout4 << "Device name : " << (*devlist_ptr)[i].in() << endl;
		device_list.push_back(new AxisG2Scan(this, (*devlist_ptr)[i]));
	}

	//	Manage dynamic attributes if any
	erase_dynamic_attributes(devlist_ptr, get_class_attr()->get_attr_list());

	//	Export devices to the outside world
	for (unsigned long i=1 ; i<=devlist_ptr->length() ; i++)
	{
		//	Add dynamic attributes if any
		AxisG2Scan *dev = static_cast<AxisG2Scan *>(device_list[device_list.size()-i]);
		dev->add_dynamic_attributes();

		//	Check before if database used.
		if ((Tango::Util::_UseDb == true) && (Tango::Util::_FileDb == false))
			export_device(dev);
		else
			export_device(dev, dev->get_name().c_str());
	}

	/*----- PROTECTED REGION ID(AxisG2ScanClass::device_factory_after) ENABLED START -----*/
	
	//	Add your own code
	
	/*----- PROTECTED REGION END -----*/	//	AxisG2ScanClass::device_factory_after
}
//--------------------------------------------------------
/**
 *	Method      : AxisG2ScanClass::attribute_factory()
 *	Description : Create the attribute object(s)
 *                and store them in the attribute list
 */
//--------------------------------------------------------
void AxisG2ScanClass::attribute_factory(vector<Tango::Attr *> &att_list)
{
	/*----- PROTECTED REGION ID(AxisG2ScanClass::attribute_factory_before) ENABLED START -----*/
	
	//	Add your own code
	
	/*----- PROTECTED REGION END -----*/	//	AxisG2ScanClass::attribute_factory_before
	//	Attribute : ScanBegin
	ScanBeginAttrib	*scanbegin = new ScanBeginAttrib();
	Tango::UserDefaultAttrProp	scanbegin_prop;
	//	description	not set for ScanBegin
	//	label	not set for ScanBegin
	//	unit	not set for ScanBegin
	//	standard_unit	not set for ScanBegin
	//	display_unit	not set for ScanBegin
	//	format	not set for ScanBegin
	//	max_value	not set for ScanBegin
	//	min_value	not set for ScanBegin
	//	max_alarm	not set for ScanBegin
	//	min_alarm	not set for ScanBegin
	//	max_warning	not set for ScanBegin
	//	min_warning	not set for ScanBegin
	//	delta_t	not set for ScanBegin
	//	delta_val	not set for ScanBegin
	
	scanbegin->set_default_properties(scanbegin_prop);
	//	Not Polled
	scanbegin->set_disp_level(Tango::OPERATOR);
	scanbegin->set_memorized();
	scanbegin->set_memorized_init(true);
	att_list.push_back(scanbegin);

	//	Attribute : ScanEnd
	ScanEndAttrib	*scanend = new ScanEndAttrib();
	Tango::UserDefaultAttrProp	scanend_prop;
	//	description	not set for ScanEnd
	//	label	not set for ScanEnd
	//	unit	not set for ScanEnd
	//	standard_unit	not set for ScanEnd
	//	display_unit	not set for ScanEnd
	//	format	not set for ScanEnd
	//	max_value	not set for ScanEnd
	//	min_value	not set for ScanEnd
	//	max_alarm	not set for ScanEnd
	//	min_alarm	not set for ScanEnd
	//	max_warning	not set for ScanEnd
	//	min_warning	not set for ScanEnd
	//	delta_t	not set for ScanEnd
	//	delta_val	not set for ScanEnd
	
	scanend->set_default_properties(scanend_prop);
	//	Not Polled
	scanend->set_disp_level(Tango::OPERATOR);
	scanend->set_memorized();
	scanend->set_memorized_init(true);
	att_list.push_back(scanend);

	//	Attribute : ScanSpeed
	ScanSpeedAttrib	*scanspeed = new ScanSpeedAttrib();
	Tango::UserDefaultAttrProp	scanspeed_prop;
	//	description	not set for ScanSpeed
	//	label	not set for ScanSpeed
	//	unit	not set for ScanSpeed
	//	standard_unit	not set for ScanSpeed
	//	display_unit	not set for ScanSpeed
	//	format	not set for ScanSpeed
	//	max_value	not set for ScanSpeed
	//	min_value	not set for ScanSpeed
	//	max_alarm	not set for ScanSpeed
	//	min_alarm	not set for ScanSpeed
	//	max_warning	not set for ScanSpeed
	//	min_warning	not set for ScanSpeed
	//	delta_t	not set for ScanSpeed
	//	delta_val	not set for ScanSpeed
	
	scanspeed->set_default_properties(scanspeed_prop);
	//	Not Polled
	scanspeed->set_disp_level(Tango::OPERATOR);
	scanspeed->set_memorized();
	scanspeed->set_memorized_init(true);
	att_list.push_back(scanspeed);

	//	Attribute : ScanAcceleration
	ScanAccelerationAttrib	*scanacceleration = new ScanAccelerationAttrib();
	Tango::UserDefaultAttrProp	scanacceleration_prop;
	//	description	not set for ScanAcceleration
	//	label	not set for ScanAcceleration
	//	unit	not set for ScanAcceleration
	//	standard_unit	not set for ScanAcceleration
	//	display_unit	not set for ScanAcceleration
	//	format	not set for ScanAcceleration
	//	max_value	not set for ScanAcceleration
	//	min_value	not set for ScanAcceleration
	//	max_alarm	not set for ScanAcceleration
	//	min_alarm	not set for ScanAcceleration
	//	max_warning	not set for ScanAcceleration
	//	min_warning	not set for ScanAcceleration
	//	delta_t	not set for ScanAcceleration
	//	delta_val	not set for ScanAcceleration
	
	scanacceleration->set_default_properties(scanacceleration_prop);
	//	Not Polled
	scanacceleration->set_disp_level(Tango::OPERATOR);
	scanacceleration->set_memorized();
	scanacceleration->set_memorized_init(true);
	att_list.push_back(scanacceleration);

	//	Attribute : ScanDeceleration
	ScanDecelerationAttrib	*scandeceleration = new ScanDecelerationAttrib();
	Tango::UserDefaultAttrProp	scandeceleration_prop;
	//	description	not set for ScanDeceleration
	//	label	not set for ScanDeceleration
	//	unit	not set for ScanDeceleration
	//	standard_unit	not set for ScanDeceleration
	//	display_unit	not set for ScanDeceleration
	//	format	not set for ScanDeceleration
	//	max_value	not set for ScanDeceleration
	//	min_value	not set for ScanDeceleration
	//	max_alarm	not set for ScanDeceleration
	//	min_alarm	not set for ScanDeceleration
	//	max_warning	not set for ScanDeceleration
	//	min_warning	not set for ScanDeceleration
	//	delta_t	not set for ScanDeceleration
	//	delta_val	not set for ScanDeceleration
	
	scandeceleration->set_default_properties(scandeceleration_prop);
	//	Not Polled
	scandeceleration->set_disp_level(Tango::OPERATOR);
	scandeceleration->set_memorized();
	scandeceleration->set_memorized_init(true);
	att_list.push_back(scandeceleration);

	//	Attribute : ScanFSM
	ScanFSMAttrib	*scanfsm = new ScanFSMAttrib();
	Tango::UserDefaultAttrProp	scanfsm_prop;
	//	description	not set for ScanFSM
	//	label	not set for ScanFSM
	//	unit	not set for ScanFSM
	//	standard_unit	not set for ScanFSM
	//	display_unit	not set for ScanFSM
	//	format	not set for ScanFSM
	//	max_value	not set for ScanFSM
	//	min_value	not set for ScanFSM
	//	max_alarm	not set for ScanFSM
	//	min_alarm	not set for ScanFSM
	//	max_warning	not set for ScanFSM
	//	min_warning	not set for ScanFSM
	//	delta_t	not set for ScanFSM
	//	delta_val	not set for ScanFSM
	
	scanfsm->set_default_properties(scanfsm_prop);
	scanfsm->set_polling_period(1000);
	scanfsm->set_disp_level(Tango::EXPERT);
	//	Not Memorized
	att_list.push_back(scanfsm);

	//	Attribute : ScanBeginBN
	ScanBeginBNAttrib	*scanbeginbn = new ScanBeginBNAttrib();
	Tango::UserDefaultAttrProp	scanbeginbn_prop;
	//	description	not set for ScanBeginBN
	//	label	not set for ScanBeginBN
	//	unit	not set for ScanBeginBN
	//	standard_unit	not set for ScanBeginBN
	//	display_unit	not set for ScanBeginBN
	//	format	not set for ScanBeginBN
	//	max_value	not set for ScanBeginBN
	//	min_value	not set for ScanBeginBN
	//	max_alarm	not set for ScanBeginBN
	//	min_alarm	not set for ScanBeginBN
	//	max_warning	not set for ScanBeginBN
	//	min_warning	not set for ScanBeginBN
	//	delta_t	not set for ScanBeginBN
	//	delta_val	not set for ScanBeginBN
	
	scanbeginbn->set_default_properties(scanbeginbn_prop);
	//	Not Polled
	scanbeginbn->set_disp_level(Tango::EXPERT);
	//	Not Memorized
	att_list.push_back(scanbeginbn);

	//	Attribute : ScanEndBN
	ScanEndBNAttrib	*scanendbn = new ScanEndBNAttrib();
	Tango::UserDefaultAttrProp	scanendbn_prop;
	//	description	not set for ScanEndBN
	//	label	not set for ScanEndBN
	//	unit	not set for ScanEndBN
	//	standard_unit	not set for ScanEndBN
	//	display_unit	not set for ScanEndBN
	//	format	not set for ScanEndBN
	//	max_value	not set for ScanEndBN
	//	min_value	not set for ScanEndBN
	//	max_alarm	not set for ScanEndBN
	//	min_alarm	not set for ScanEndBN
	//	max_warning	not set for ScanEndBN
	//	min_warning	not set for ScanEndBN
	//	delta_t	not set for ScanEndBN
	//	delta_val	not set for ScanEndBN
	
	scanendbn->set_default_properties(scanendbn_prop);
	//	Not Polled
	scanendbn->set_disp_level(Tango::EXPERT);
	//	Not Memorized
	att_list.push_back(scanendbn);

	//	Attribute : Position
	PositionAttrib	*position = new PositionAttrib();
	Tango::UserDefaultAttrProp	position_prop;
	//	description	not set for Position
	//	label	not set for Position
	//	unit	not set for Position
	//	standard_unit	not set for Position
	//	display_unit	not set for Position
	//	format	not set for Position
	//	max_value	not set for Position
	//	min_value	not set for Position
	//	max_alarm	not set for Position
	//	min_alarm	not set for Position
	//	max_warning	not set for Position
	//	min_warning	not set for Position
	//	delta_t	not set for Position
	//	delta_val	not set for Position
	
	position->set_default_properties(position_prop);
	position->set_polling_period(1000);
	position->set_disp_level(Tango::OPERATOR);
	//	Not Memorized
	att_list.push_back(position);

	//	Attribute : ScanTotalTime
	ScanTotalTimeAttrib	*scantotaltime = new ScanTotalTimeAttrib();
	Tango::UserDefaultAttrProp	scantotaltime_prop;
	//	description	not set for ScanTotalTime
	//	label	not set for ScanTotalTime
	scantotaltime_prop.set_unit("ms");
	scantotaltime_prop.set_standard_unit("ms");
	scantotaltime_prop.set_display_unit("ms");
	scantotaltime_prop.set_format("%6.1");
	//	max_value	not set for ScanTotalTime
	//	min_value	not set for ScanTotalTime
	//	max_alarm	not set for ScanTotalTime
	//	min_alarm	not set for ScanTotalTime
	//	max_warning	not set for ScanTotalTime
	//	min_warning	not set for ScanTotalTime
	//	delta_t	not set for ScanTotalTime
	//	delta_val	not set for ScanTotalTime
	
	scantotaltime->set_default_properties(scantotaltime_prop);
	//	Not Polled
	scantotaltime->set_disp_level(Tango::EXPERT);
	//	Not Memorized
	att_list.push_back(scantotaltime);

	//	Attribute : ExtStatus
	ExtStatusAttrib	*extstatus = new ExtStatusAttrib();
	Tango::UserDefaultAttrProp	extstatus_prop;
	//	description	not set for ExtStatus
	//	label	not set for ExtStatus
	//	unit	not set for ExtStatus
	//	standard_unit	not set for ExtStatus
	//	display_unit	not set for ExtStatus
	//	format	not set for ExtStatus
	//	max_value	not set for ExtStatus
	//	min_value	not set for ExtStatus
	//	max_alarm	not set for ExtStatus
	//	min_alarm	not set for ExtStatus
	//	max_warning	not set for ExtStatus
	//	min_warning	not set for ExtStatus
	//	delta_t	not set for ExtStatus
	//	delta_val	not set for ExtStatus
	
	extstatus->set_default_properties(extstatus_prop);
	//	Not Polled
	extstatus->set_disp_level(Tango::EXPERT);
	//	Not Memorized
	att_list.push_back(extstatus);

	//	Attribute : ScanPositions
	ScanPositionsAttrib	*scanpositions = new ScanPositionsAttrib();
	Tango::UserDefaultAttrProp	scanpositions_prop;
	//	description	not set for ScanPositions
	//	label	not set for ScanPositions
	//	unit	not set for ScanPositions
	//	standard_unit	not set for ScanPositions
	//	display_unit	not set for ScanPositions
	//	format	not set for ScanPositions
	//	max_value	not set for ScanPositions
	//	min_value	not set for ScanPositions
	//	max_alarm	not set for ScanPositions
	//	min_alarm	not set for ScanPositions
	//	max_warning	not set for ScanPositions
	//	min_warning	not set for ScanPositions
	//	delta_t	not set for ScanPositions
	//	delta_val	not set for ScanPositions
	
	scanpositions->set_default_properties(scanpositions_prop);
	//	Not Polled
	scanpositions->set_disp_level(Tango::OPERATOR);
	//	Not Memorized
	att_list.push_back(scanpositions);

	//	Attribute : ScanBN
	ScanBNAttrib	*scanbn = new ScanBNAttrib();
	Tango::UserDefaultAttrProp	scanbn_prop;
	//	description	not set for ScanBN
	//	label	not set for ScanBN
	//	unit	not set for ScanBN
	//	standard_unit	not set for ScanBN
	//	display_unit	not set for ScanBN
	//	format	not set for ScanBN
	//	max_value	not set for ScanBN
	//	min_value	not set for ScanBN
	//	max_alarm	not set for ScanBN
	//	min_alarm	not set for ScanBN
	//	max_warning	not set for ScanBN
	//	min_warning	not set for ScanBN
	//	delta_t	not set for ScanBN
	//	delta_val	not set for ScanBN
	
	scanbn->set_default_properties(scanbn_prop);
	//	Not Polled
	scanbn->set_disp_level(Tango::OPERATOR);
	//	Not Memorized
	att_list.push_back(scanbn);


	//	Create a list of static attributes
	create_static_attribute_list(get_class_attr()->get_attr_list());
	/*----- PROTECTED REGION ID(AxisG2ScanClass::attribute_factory_after) ENABLED START -----*/
	
	//	Add your own code
	
	/*----- PROTECTED REGION END -----*/	//	AxisG2ScanClass::attribute_factory_after
}
//--------------------------------------------------------
/**
 *	Method      : AxisG2ScanClass::pipe_factory()
 *	Description : Create the pipe object(s)
 *                and store them in the pipe list
 */
//--------------------------------------------------------
void AxisG2ScanClass::pipe_factory()
{
	/*----- PROTECTED REGION ID(AxisG2ScanClass::pipe_factory_before) ENABLED START -----*/
	
	//	Add your own code
	
	/*----- PROTECTED REGION END -----*/	//	AxisG2ScanClass::pipe_factory_before
	/*----- PROTECTED REGION ID(AxisG2ScanClass::pipe_factory_after) ENABLED START -----*/
	
	//	Add your own code
	
	/*----- PROTECTED REGION END -----*/	//	AxisG2ScanClass::pipe_factory_after
}
//--------------------------------------------------------
/**
 *	Method      : AxisG2ScanClass::command_factory()
 *	Description : Create the command object(s)
 *                and store them in the command list
 */
//--------------------------------------------------------
void AxisG2ScanClass::command_factory()
{
	/*----- PROTECTED REGION ID(AxisG2ScanClass::command_factory_before) ENABLED START -----*/
	
	//	Add your own code
	
	/*----- PROTECTED REGION END -----*/	//	AxisG2ScanClass::command_factory_before


	//	Command Start
	StartClass	*pStartCmd =
		new StartClass("Start",
			Tango::DEV_VOID, Tango::DEV_VOID,
			"",
			"",
			Tango::OPERATOR);
	command_list.push_back(pStartCmd);

	//	Command Stop
	StopClass	*pStopCmd =
		new StopClass("Stop",
			Tango::DEV_VOID, Tango::DEV_VOID,
			"",
			"",
			Tango::OPERATOR);
	command_list.push_back(pStopCmd);

	//	Command RevStart
	RevStartClass	*pRevStartCmd =
		new RevStartClass("RevStart",
			Tango::DEV_VOID, Tango::DEV_VOID,
			"",
			"",
			Tango::OPERATOR);
	command_list.push_back(pRevStartCmd);

	/*----- PROTECTED REGION ID(AxisG2ScanClass::command_factory_after) ENABLED START -----*/
	
	//	Add your own code
	
	/*----- PROTECTED REGION END -----*/	//	AxisG2ScanClass::command_factory_after
}

//===================================================================
//	Dynamic attributes related methods
//===================================================================

//--------------------------------------------------------
/**
 * method : 		AxisG2ScanClass::create_static_attribute_list
 * description : 	Create the a list of static attributes
 *
 * @param	att_list	the ceated attribute list
 */
//--------------------------------------------------------
void AxisG2ScanClass::create_static_attribute_list(vector<Tango::Attr *> &att_list)
{
	for (unsigned long i=0 ; i<att_list.size() ; i++)
	{
		string att_name(att_list[i]->get_name());
		transform(att_name.begin(), att_name.end(), att_name.begin(), ::tolower);
		defaultAttList.push_back(att_name);
	}

	cout2 << defaultAttList.size() << " attributes in default list" << endl;

	/*----- PROTECTED REGION ID(AxisG2ScanClass::create_static_att_list) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	AxisG2ScanClass::create_static_att_list
}


//--------------------------------------------------------
/**
 * method : 		AxisG2ScanClass::erase_dynamic_attributes
 * description : 	delete the dynamic attributes if any.
 *
 * @param	devlist_ptr	the device list pointer
 * @param	list of all attributes
 */
//--------------------------------------------------------
void AxisG2ScanClass::erase_dynamic_attributes(const Tango::DevVarStringArray *devlist_ptr, vector<Tango::Attr *> &att_list)
{
	Tango::Util *tg = Tango::Util::instance();

	for (unsigned long i=0 ; i<devlist_ptr->length() ; i++)
	{
		Tango::DeviceImpl *dev_impl = tg->get_device_by_name(((string)(*devlist_ptr)[i]).c_str());
		AxisG2Scan *dev = static_cast<AxisG2Scan *> (dev_impl);

		vector<Tango::Attribute *> &dev_att_list = dev->get_device_attr()->get_attribute_list();
		vector<Tango::Attribute *>::iterator ite_att;
		for (ite_att=dev_att_list.begin() ; ite_att != dev_att_list.end() ; ++ite_att)
		{
			string att_name((*ite_att)->get_name_lower());
			if ((att_name == "state") || (att_name == "status"))
				continue;
			vector<string>::iterator ite_str = find(defaultAttList.begin(), defaultAttList.end(), att_name);
			if (ite_str == defaultAttList.end())
			{
				cout2 << att_name << " is a UNWANTED dynamic attribute for device " << (*devlist_ptr)[i] << endl;
				Tango::Attribute &att = dev->get_device_attr()->get_attr_by_name(att_name.c_str());
				dev->remove_attribute(att_list[att.get_attr_idx()], true, false);
				--ite_att;
			}
		}
	}
	/*----- PROTECTED REGION ID(AxisG2ScanClass::erase_dynamic_attributes) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	AxisG2ScanClass::erase_dynamic_attributes
}

//--------------------------------------------------------
/**
 *	Method      : AxisG2ScanClass::get_attr_by_name()
 *	Description : returns Tango::Attr * object found by name
 */
//--------------------------------------------------------
Tango::Attr *AxisG2ScanClass::get_attr_object_by_name(vector<Tango::Attr *> &att_list, string attname)
{
	vector<Tango::Attr *>::iterator it;
	for (it=att_list.begin() ; it<att_list.end() ; ++it)
		if ((*it)->get_name()==attname)
			return (*it);
	//	Attr does not exist
	return NULL;
}


/*----- PROTECTED REGION ID(AxisG2ScanClass::Additional Methods) ENABLED START -----*/

/*----- PROTECTED REGION END -----*/	//	AxisG2ScanClass::Additional Methods
} //	namespace
