/*----- PROTECTED REGION ID(AxisG2ScanClass.h) ENABLED START -----*/
//=============================================================================
//
// file :        AxisG2ScanClass.h
//
// description : Include for the AxisG2Scan root class.
//               This class is the singleton class for
//                the AxisG2Scan device class.
//               It contains all properties and methods which the 
//               AxisG2Scan requires only once e.g. the commands.
//
// project :     
//
// This file is part of Tango device class.
// 
// Tango is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
// 
// Tango is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// 
// You should have received a copy of the GNU General Public License
// along with Tango.  If not, see <http://www.gnu.org/licenses/>.
// 
//
//
//=============================================================================
//                This file is generated by POGO
//        (Program Obviously used to Generate tango Object)
//=============================================================================


#ifndef AxisG2ScanClass_H
#define AxisG2ScanClass_H

#include <tango.h>
#include <AxisG2Scan.h>


/*----- PROTECTED REGION END -----*/	//	AxisG2ScanClass.h


namespace AxisG2Scan_ns
{
/*----- PROTECTED REGION ID(AxisG2ScanClass::classes for dynamic creation) ENABLED START -----*/


/*----- PROTECTED REGION END -----*/	//	AxisG2ScanClass::classes for dynamic creation

//=========================================
//	Define classes for attributes
//=========================================
//	Attribute ScanBegin class definition
class ScanBeginAttrib: public Tango::Attr
{
public:
	ScanBeginAttrib():Attr("ScanBegin",
			Tango::DEV_DOUBLE, Tango::READ_WRITE) {};
	~ScanBeginAttrib() {};
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<AxisG2Scan *>(dev))->read_ScanBegin(att);}
	virtual void write(Tango::DeviceImpl *dev,Tango::WAttribute &att)
		{(static_cast<AxisG2Scan *>(dev))->write_ScanBegin(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<AxisG2Scan *>(dev))->is_ScanBegin_allowed(ty);}
};

//	Attribute ScanEnd class definition
class ScanEndAttrib: public Tango::Attr
{
public:
	ScanEndAttrib():Attr("ScanEnd",
			Tango::DEV_DOUBLE, Tango::READ_WRITE) {};
	~ScanEndAttrib() {};
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<AxisG2Scan *>(dev))->read_ScanEnd(att);}
	virtual void write(Tango::DeviceImpl *dev,Tango::WAttribute &att)
		{(static_cast<AxisG2Scan *>(dev))->write_ScanEnd(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<AxisG2Scan *>(dev))->is_ScanEnd_allowed(ty);}
};

//	Attribute ScanSpeed class definition
class ScanSpeedAttrib: public Tango::Attr
{
public:
	ScanSpeedAttrib():Attr("ScanSpeed",
			Tango::DEV_DOUBLE, Tango::READ_WRITE) {};
	~ScanSpeedAttrib() {};
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<AxisG2Scan *>(dev))->read_ScanSpeed(att);}
	virtual void write(Tango::DeviceImpl *dev,Tango::WAttribute &att)
		{(static_cast<AxisG2Scan *>(dev))->write_ScanSpeed(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<AxisG2Scan *>(dev))->is_ScanSpeed_allowed(ty);}
};

//	Attribute ScanAcceleration class definition
class ScanAccelerationAttrib: public Tango::Attr
{
public:
	ScanAccelerationAttrib():Attr("ScanAcceleration",
			Tango::DEV_DOUBLE, Tango::READ_WRITE) {};
	~ScanAccelerationAttrib() {};
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<AxisG2Scan *>(dev))->read_ScanAcceleration(att);}
	virtual void write(Tango::DeviceImpl *dev,Tango::WAttribute &att)
		{(static_cast<AxisG2Scan *>(dev))->write_ScanAcceleration(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<AxisG2Scan *>(dev))->is_ScanAcceleration_allowed(ty);}
};

//	Attribute ScanDeceleration class definition
class ScanDecelerationAttrib: public Tango::Attr
{
public:
	ScanDecelerationAttrib():Attr("ScanDeceleration",
			Tango::DEV_DOUBLE, Tango::READ_WRITE) {};
	~ScanDecelerationAttrib() {};
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<AxisG2Scan *>(dev))->read_ScanDeceleration(att);}
	virtual void write(Tango::DeviceImpl *dev,Tango::WAttribute &att)
		{(static_cast<AxisG2Scan *>(dev))->write_ScanDeceleration(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<AxisG2Scan *>(dev))->is_ScanDeceleration_allowed(ty);}
};

//	Attribute ScanFSM class definition
class ScanFSMAttrib: public Tango::Attr
{
public:
	ScanFSMAttrib():Attr("ScanFSM",
			Tango::DEV_STRING, Tango::READ) {};
	~ScanFSMAttrib() {};
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<AxisG2Scan *>(dev))->read_ScanFSM(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<AxisG2Scan *>(dev))->is_ScanFSM_allowed(ty);}
};

//	Attribute ScanBeginBN class definition
class ScanBeginBNAttrib: public Tango::Attr
{
public:
	ScanBeginBNAttrib():Attr("ScanBeginBN",
			Tango::DEV_LONG, Tango::READ) {};
	~ScanBeginBNAttrib() {};
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<AxisG2Scan *>(dev))->read_ScanBeginBN(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<AxisG2Scan *>(dev))->is_ScanBeginBN_allowed(ty);}
};

//	Attribute ScanEndBN class definition
class ScanEndBNAttrib: public Tango::Attr
{
public:
	ScanEndBNAttrib():Attr("ScanEndBN",
			Tango::DEV_LONG, Tango::READ) {};
	~ScanEndBNAttrib() {};
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<AxisG2Scan *>(dev))->read_ScanEndBN(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<AxisG2Scan *>(dev))->is_ScanEndBN_allowed(ty);}
};

//	Attribute Position class definition
class PositionAttrib: public Tango::Attr
{
public:
	PositionAttrib():Attr("Position",
			Tango::DEV_DOUBLE, Tango::READ) {};
	~PositionAttrib() {};
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<AxisG2Scan *>(dev))->read_Position(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<AxisG2Scan *>(dev))->is_Position_allowed(ty);}
};

//	Attribute ScanTotalTime class definition
class ScanTotalTimeAttrib: public Tango::Attr
{
public:
	ScanTotalTimeAttrib():Attr("ScanTotalTime",
			Tango::DEV_DOUBLE, Tango::READ) {};
	~ScanTotalTimeAttrib() {};
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<AxisG2Scan *>(dev))->read_ScanTotalTime(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<AxisG2Scan *>(dev))->is_ScanTotalTime_allowed(ty);}
};

//	Attribute ExtStatus class definition
class ExtStatusAttrib: public Tango::SpectrumAttr
{
public:
	ExtStatusAttrib():SpectrumAttr("ExtStatus",
			Tango::DEV_STRING, Tango::READ, 100) {};
	~ExtStatusAttrib() {};
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<AxisG2Scan *>(dev))->read_ExtStatus(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<AxisG2Scan *>(dev))->is_ExtStatus_allowed(ty);}
};

//	Attribute ScanPositions class definition
class ScanPositionsAttrib: public Tango::SpectrumAttr
{
public:
	ScanPositionsAttrib():SpectrumAttr("ScanPositions",
			Tango::DEV_DOUBLE, Tango::READ, 10000) {};
	~ScanPositionsAttrib() {};
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<AxisG2Scan *>(dev))->read_ScanPositions(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<AxisG2Scan *>(dev))->is_ScanPositions_allowed(ty);}
};

//	Attribute ScanBN class definition
class ScanBNAttrib: public Tango::SpectrumAttr
{
public:
	ScanBNAttrib():SpectrumAttr("ScanBN",
			Tango::DEV_LONG, Tango::READ, 10000) {};
	~ScanBNAttrib() {};
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<AxisG2Scan *>(dev))->read_ScanBN(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<AxisG2Scan *>(dev))->is_ScanBN_allowed(ty);}
};


//=========================================
//	Define classes for commands
//=========================================
//	Command Start class definition
class StartClass : public Tango::Command
{
public:
	StartClass(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out,
				   const char        *in_desc,
				   const char        *out_desc,
				   Tango::DispLevel  level)
	:Command(name,in,out,in_desc,out_desc, level)	{};

	StartClass(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out)
	:Command(name,in,out)	{};
	~StartClass() {};
	
	virtual CORBA::Any *execute (Tango::DeviceImpl *dev, const CORBA::Any &any);
	virtual bool is_allowed (Tango::DeviceImpl *dev, const CORBA::Any &any)
	{return (static_cast<AxisG2Scan *>(dev))->is_Start_allowed(any);}
};

//	Command Stop class definition
class StopClass : public Tango::Command
{
public:
	StopClass(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out,
				   const char        *in_desc,
				   const char        *out_desc,
				   Tango::DispLevel  level)
	:Command(name,in,out,in_desc,out_desc, level)	{};

	StopClass(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out)
	:Command(name,in,out)	{};
	~StopClass() {};
	
	virtual CORBA::Any *execute (Tango::DeviceImpl *dev, const CORBA::Any &any);
	virtual bool is_allowed (Tango::DeviceImpl *dev, const CORBA::Any &any)
	{return (static_cast<AxisG2Scan *>(dev))->is_Stop_allowed(any);}
};

//	Command RevStart class definition
class RevStartClass : public Tango::Command
{
public:
	RevStartClass(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out,
				   const char        *in_desc,
				   const char        *out_desc,
				   Tango::DispLevel  level)
	:Command(name,in,out,in_desc,out_desc, level)	{};

	RevStartClass(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out)
	:Command(name,in,out)	{};
	~RevStartClass() {};
	
	virtual CORBA::Any *execute (Tango::DeviceImpl *dev, const CORBA::Any &any);
	virtual bool is_allowed (Tango::DeviceImpl *dev, const CORBA::Any &any)
	{return (static_cast<AxisG2Scan *>(dev))->is_RevStart_allowed(any);}
};


/**
 *	The AxisG2ScanClass singleton definition
 */

#ifdef _TG_WINDOWS_
class __declspec(dllexport)  AxisG2ScanClass : public Tango::DeviceClass
#else
class AxisG2ScanClass : public Tango::DeviceClass
#endif
{
	/*----- PROTECTED REGION ID(AxisG2ScanClass::Additionnal DServer data members) ENABLED START -----*/
	
	
	/*----- PROTECTED REGION END -----*/	//	AxisG2ScanClass::Additionnal DServer data members

	public:
		//	write class properties data members
		Tango::DbData	cl_prop;
		Tango::DbData	cl_def_prop;
		Tango::DbData	dev_def_prop;
	
		//	Method prototypes
		static AxisG2ScanClass *init(const char *);
		static AxisG2ScanClass *instance();
		~AxisG2ScanClass();
		Tango::DbDatum	get_class_property(string &);
		Tango::DbDatum	get_default_device_property(string &);
		Tango::DbDatum	get_default_class_property(string &);
	
	protected:
		AxisG2ScanClass(string &);
		static AxisG2ScanClass *_instance;
		void command_factory();
		void attribute_factory(vector<Tango::Attr *> &);
		void pipe_factory();
		void write_class_property();
		void set_default_property();
		void get_class_property();
		string get_cvstag();
		string get_cvsroot();
	
	private:
		void device_factory(const Tango::DevVarStringArray *);
		void create_static_attribute_list(vector<Tango::Attr *> &);
		void erase_dynamic_attributes(const Tango::DevVarStringArray *,vector<Tango::Attr *> &);
		vector<string>	defaultAttList;
		Tango::Attr *get_attr_object_by_name(vector<Tango::Attr *> &att_list, string attname);
};

}	//	End of namespace

#endif   //	AxisG2Scan_H
