#ifndef AXISG2SCANERRORS_H_
#define AXISG2SCANERRORS_H_

namespace AxisG2Scan_ns {

typedef enum {
        AG2SC_E000,
        AG2SC_E001,
        AG2SC_E002,
        AG2SC_E003,
        AG2SC_E004,
        AG2SC_E005,
        AG2SC_E006,
        AG2SC_E007,
        AG2SC_E008,
        AG2SC_E009,
        AG2SC_E999
} AG2SCError_t;


inline string  ag2sc_error_str(AG2SCError_t e){
        switch(e){
                case AG2SC_E000: return "AG2SC_E000: error in unknown device"; break;
                case AG2SC_E001: return "AG2SC_E001: error in getting device configuration"; break;
                case AG2SC_E002: return "AG2SC_E002: error in getting device property"; break;
                case AG2SC_E003: return "AG2SC_E003: no axis driver defined"; break;
                case AG2SC_E004: return "AG2SC_E004: error in reading device attributes"; break;
                case AG2SC_E005: return "AG2SC_E005: error in device attributes answer"; break;
                case AG2SC_E006: return "AG2SC_E006: error in getting buffer device"; break;
                case AG2SC_E007: return "AG2SC_E007: no axis channel defined"; break;
                case AG2SC_E008: return "AG2SC_E008: no axis per defined"; break;
                case AG2SC_E009: return "AG2SC_E009: no axis peo defined"; break;
                default:
                        {
                          std::stringstream ss;
                          ss << "-?- [AG2SCError= " << e << " ]";
                          return ss.str();
                        }
                        break;
        }
        return "-?-";
}

} /* namespace */

#endif /* AXISG2SCANERRORS_H_ */
