/*----- PROTECTED REGION ID(AxisG2ScanStateMachine.cpp) ENABLED START -----*/
//=============================================================================
//
// file :        AxisG2ScanStateMachine.cpp
//
// description : State machine file for the AxisG2Scan class
//
// project :     
//
// This file is part of Tango device class.
// 
// Tango is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
// 
// Tango is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// 
// You should have received a copy of the GNU General Public License
// along with Tango.  If not, see <http://www.gnu.org/licenses/>.
// 
//
//
//=============================================================================
//                This file is generated by POGO
//        (Program Obviously used to Generate tango Object)
//=============================================================================

#include <AxisG2Scan.h>

/*----- PROTECTED REGION END -----*/	//	AxisG2Scan::AxisG2ScanStateMachine.cpp

//================================================================
//  States  |  Description
//================================================================


namespace AxisG2Scan_ns
{
//=================================================
//		Attributes Allowed Methods
//=================================================

//--------------------------------------------------------
/**
 *	Method      : AxisG2Scan::is_ScanBegin_allowed()
 *	Description : Execution allowed for ScanBegin attribute
 */
//--------------------------------------------------------
bool AxisG2Scan::is_ScanBegin_allowed(TANGO_UNUSED(Tango::AttReqType type))
{
	//	Not any excluded states for ScanBegin attribute in Write access.
	/*----- PROTECTED REGION ID(AxisG2Scan::ScanBeginStateAllowed_WRITE) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	AxisG2Scan::ScanBeginStateAllowed_WRITE

	//	Not any excluded states for ScanBegin attribute in read access.
	/*----- PROTECTED REGION ID(AxisG2Scan::ScanBeginStateAllowed_READ) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	AxisG2Scan::ScanBeginStateAllowed_READ
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : AxisG2Scan::is_ScanEnd_allowed()
 *	Description : Execution allowed for ScanEnd attribute
 */
//--------------------------------------------------------
bool AxisG2Scan::is_ScanEnd_allowed(TANGO_UNUSED(Tango::AttReqType type))
{
	//	Not any excluded states for ScanEnd attribute in Write access.
	/*----- PROTECTED REGION ID(AxisG2Scan::ScanEndStateAllowed_WRITE) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	AxisG2Scan::ScanEndStateAllowed_WRITE

	//	Not any excluded states for ScanEnd attribute in read access.
	/*----- PROTECTED REGION ID(AxisG2Scan::ScanEndStateAllowed_READ) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	AxisG2Scan::ScanEndStateAllowed_READ
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : AxisG2Scan::is_ScanSpeed_allowed()
 *	Description : Execution allowed for ScanSpeed attribute
 */
//--------------------------------------------------------
bool AxisG2Scan::is_ScanSpeed_allowed(TANGO_UNUSED(Tango::AttReqType type))
{
	//	Not any excluded states for ScanSpeed attribute in Write access.
	/*----- PROTECTED REGION ID(AxisG2Scan::ScanSpeedStateAllowed_WRITE) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	AxisG2Scan::ScanSpeedStateAllowed_WRITE

	//	Not any excluded states for ScanSpeed attribute in read access.
	/*----- PROTECTED REGION ID(AxisG2Scan::ScanSpeedStateAllowed_READ) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	AxisG2Scan::ScanSpeedStateAllowed_READ
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : AxisG2Scan::is_ScanAcceleration_allowed()
 *	Description : Execution allowed for ScanAcceleration attribute
 */
//--------------------------------------------------------
bool AxisG2Scan::is_ScanAcceleration_allowed(TANGO_UNUSED(Tango::AttReqType type))
{
	//	Not any excluded states for ScanAcceleration attribute in Write access.
	/*----- PROTECTED REGION ID(AxisG2Scan::ScanAccelerationStateAllowed_WRITE) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	AxisG2Scan::ScanAccelerationStateAllowed_WRITE

	//	Not any excluded states for ScanAcceleration attribute in read access.
	/*----- PROTECTED REGION ID(AxisG2Scan::ScanAccelerationStateAllowed_READ) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	AxisG2Scan::ScanAccelerationStateAllowed_READ
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : AxisG2Scan::is_ScanDeceleration_allowed()
 *	Description : Execution allowed for ScanDeceleration attribute
 */
//--------------------------------------------------------
bool AxisG2Scan::is_ScanDeceleration_allowed(TANGO_UNUSED(Tango::AttReqType type))
{
	//	Not any excluded states for ScanDeceleration attribute in Write access.
	/*----- PROTECTED REGION ID(AxisG2Scan::ScanDecelerationStateAllowed_WRITE) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	AxisG2Scan::ScanDecelerationStateAllowed_WRITE

	//	Not any excluded states for ScanDeceleration attribute in read access.
	/*----- PROTECTED REGION ID(AxisG2Scan::ScanDecelerationStateAllowed_READ) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	AxisG2Scan::ScanDecelerationStateAllowed_READ
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : AxisG2Scan::is_ScanFSM_allowed()
 *	Description : Execution allowed for ScanFSM attribute
 */
//--------------------------------------------------------
bool AxisG2Scan::is_ScanFSM_allowed(TANGO_UNUSED(Tango::AttReqType type))
{

	//	Not any excluded states for ScanFSM attribute in read access.
	/*----- PROTECTED REGION ID(AxisG2Scan::ScanFSMStateAllowed_READ) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	AxisG2Scan::ScanFSMStateAllowed_READ
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : AxisG2Scan::is_ScanBeginBN_allowed()
 *	Description : Execution allowed for ScanBeginBN attribute
 */
//--------------------------------------------------------
bool AxisG2Scan::is_ScanBeginBN_allowed(TANGO_UNUSED(Tango::AttReqType type))
{

	//	Not any excluded states for ScanBeginBN attribute in read access.
	/*----- PROTECTED REGION ID(AxisG2Scan::ScanBeginBNStateAllowed_READ) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	AxisG2Scan::ScanBeginBNStateAllowed_READ
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : AxisG2Scan::is_ScanEndBN_allowed()
 *	Description : Execution allowed for ScanEndBN attribute
 */
//--------------------------------------------------------
bool AxisG2Scan::is_ScanEndBN_allowed(TANGO_UNUSED(Tango::AttReqType type))
{

	//	Not any excluded states for ScanEndBN attribute in read access.
	/*----- PROTECTED REGION ID(AxisG2Scan::ScanEndBNStateAllowed_READ) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	AxisG2Scan::ScanEndBNStateAllowed_READ
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : AxisG2Scan::is_Position_allowed()
 *	Description : Execution allowed for Position attribute
 */
//--------------------------------------------------------
bool AxisG2Scan::is_Position_allowed(TANGO_UNUSED(Tango::AttReqType type))
{

	//	Not any excluded states for Position attribute in read access.
	/*----- PROTECTED REGION ID(AxisG2Scan::PositionStateAllowed_READ) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	AxisG2Scan::PositionStateAllowed_READ
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : AxisG2Scan::is_ScanTotalTime_allowed()
 *	Description : Execution allowed for ScanTotalTime attribute
 */
//--------------------------------------------------------
bool AxisG2Scan::is_ScanTotalTime_allowed(TANGO_UNUSED(Tango::AttReqType type))
{

	//	Not any excluded states for ScanTotalTime attribute in read access.
	/*----- PROTECTED REGION ID(AxisG2Scan::ScanTotalTimeStateAllowed_READ) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	AxisG2Scan::ScanTotalTimeStateAllowed_READ
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : AxisG2Scan::is_ExtStatus_allowed()
 *	Description : Execution allowed for ExtStatus attribute
 */
//--------------------------------------------------------
bool AxisG2Scan::is_ExtStatus_allowed(TANGO_UNUSED(Tango::AttReqType type))
{

	//	Not any excluded states for ExtStatus attribute in read access.
	/*----- PROTECTED REGION ID(AxisG2Scan::ExtStatusStateAllowed_READ) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	AxisG2Scan::ExtStatusStateAllowed_READ
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : AxisG2Scan::is_ScanPositions_allowed()
 *	Description : Execution allowed for ScanPositions attribute
 */
//--------------------------------------------------------
bool AxisG2Scan::is_ScanPositions_allowed(TANGO_UNUSED(Tango::AttReqType type))
{

	//	Not any excluded states for ScanPositions attribute in read access.
	/*----- PROTECTED REGION ID(AxisG2Scan::ScanPositionsStateAllowed_READ) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	AxisG2Scan::ScanPositionsStateAllowed_READ
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : AxisG2Scan::is_ScanBN_allowed()
 *	Description : Execution allowed for ScanBN attribute
 */
//--------------------------------------------------------
bool AxisG2Scan::is_ScanBN_allowed(TANGO_UNUSED(Tango::AttReqType type))
{

	//	Not any excluded states for ScanBN attribute in read access.
	/*----- PROTECTED REGION ID(AxisG2Scan::ScanBNStateAllowed_READ) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	AxisG2Scan::ScanBNStateAllowed_READ
	return true;
}


//=================================================
//		Commands Allowed Methods
//=================================================

//--------------------------------------------------------
/**
 *	Method      : AxisG2Scan::is_Start_allowed()
 *	Description : Execution allowed for Start attribute
 */
//--------------------------------------------------------
bool AxisG2Scan::is_Start_allowed(TANGO_UNUSED(const CORBA::Any &any))
{
	//	Not any excluded states for Start command.
	/*----- PROTECTED REGION ID(AxisG2Scan::StartStateAllowed) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	AxisG2Scan::StartStateAllowed
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : AxisG2Scan::is_Stop_allowed()
 *	Description : Execution allowed for Stop attribute
 */
//--------------------------------------------------------
bool AxisG2Scan::is_Stop_allowed(TANGO_UNUSED(const CORBA::Any &any))
{
	//	Not any excluded states for Stop command.
	/*----- PROTECTED REGION ID(AxisG2Scan::StopStateAllowed) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	AxisG2Scan::StopStateAllowed
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : AxisG2Scan::is_RevStart_allowed()
 *	Description : Execution allowed for RevStart attribute
 */
//--------------------------------------------------------
bool AxisG2Scan::is_RevStart_allowed(TANGO_UNUSED(const CORBA::Any &any))
{
	//	Not any excluded states for RevStart command.
	/*----- PROTECTED REGION ID(AxisG2Scan::RevStartStateAllowed) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	AxisG2Scan::RevStartStateAllowed
	return true;
}


/*----- PROTECTED REGION ID(AxisG2Scan::AxisG2ScanStateAllowed.AdditionalMethods) ENABLED START -----*/

//	Additional Methods

/*----- PROTECTED REGION END -----*/	//	AxisG2Scan::AxisG2ScanStateAllowed.AdditionalMethods

}	//	End of namespace
