#ifndef _FSM_H_
#define _FSM_H_

#include <vector>
#include <stdlib.h>
#include <string>
#include <algorithm>
#include <iostream>
#include <sys/time.h>

#include "verbose.h"

#include "FSMTypes.h"

#include "AxisG2Scan.h"

namespace FSM_ns {

class FSM {
protected:
	std::string _name;
        int _verbose;

private:
	AxisG2Scan_ns::AxisG2Scan *pdev;

        FSM_t _FSM;
        FSMError_t _FSMerror;

        FSMTransitions_t _oldtr;
        FSMTransitions_t _tr;

	int wait;

	double tmp_delta_pos;

	std::string trace_err;

	double scantotaltime;
	struct timeval scan_start;

	
public:
	FSM(std::string name){ _name = name; _FSM = FSM_WAIT; _verbose=0;};
	//FSM(AxisG2Scan_ns::AxisG2Scan *dev){ pdev= dev;_name = pdev->name(); _FSM = FSM_WAIT; _verbose=0;};
	FSM(AxisG2Scan_ns::AxisG2Scan *dev){
						pdev= dev;
						char *nn = pdev->name();
						_name = nn;
						CORBA::string_free(nn);
						_FSM = FSM_WAIT;
						_verbose=0;
						trace_err = timestamp() + ".";
						scantotaltime = -1;
					   };
	~FSM()		{};

        int            	verbose()               { return _verbose;};
        void           	verbose(int b)		{ _verbose = b;};

	FSM_t  		fsm(FSMTransitions_t tr);	// proceed with FSM

	FSM_t		fsm_state() 		{ return _FSM; };
	std::string	fsm_status() 		{ return FSMName[_FSM]; };

	FSMError_t	fsm_error_state() 	{ return _FSMerror; };
	std::string	fsm_error_status() 	{ return FSMErrorName[_FSMerror]; };
	bool 		fsm_error_clear()	{ _FSMerror = FSM_E000; return true;};

	std::string	get_trace_err()		{ return trace_err; };

	double		get_scan_total_time()	{ return scantotaltime; };

	double		get_scan_calculated_time(double s, double v, double a, double d);

	void 		do_stop_1();

}; /* class FSM */

} /* namespace FSM_ns */

#endif /* _FSM_H_ */
