#ifndef _FSMTYPES_H_
#define _FSMTYPES_H_

#include <vector>
#include <stdlib.h>
#include <string>
#include <algorithm>
#include <iostream>
#include <sys/time.h>

#include "verbose.h"

namespace FSM_ns {

// min lomg poll : 500ms
#define MIN_LONG_POLL 500

typedef enum {
	FSM_ERROR,
	FSM_NOTINITED,
	FSM_INITIALIZING,
	FSM_WAIT,
	FSM_MOVING,
	FSM_START,
	FSM_POSITIONING,
	FSM_POSITIONING_WAIT,
	FSM_SCAN,
	FSM_SCAN_2,
	FSM_SCAN_WAIT_TIME,
	FSM_SCAN_WAIT,
	FSM_SCAN_END,
	FSM_STOP,
	FSM_STOP_WAIT,
	FSM_STOP_1,
	FSM_STOP_ERROR
} FSM_t;

const char * const FSMName[] = {
	"FSM_ERROR",
	"FSM_NOTINITED",
	"FSM_INITIALIZING",
	"FSM_WAIT",
	"FSM_MOVING",
	"FSM_START",
	"FSM_POSITIONING",
	"FSM_POSITIONING_WAIT",
	"FSM_SCAN",
	"FSM_SCAN_2",
	"FSM_SCAN_WAIT_TIME",
	"FSM_SCAN_WAIT",
	"FSM_SCAN_END",
	"FSM_STOP",
	"FSM_STOP_WAIT",
	"FSM_STOP_1",
	"FSM_STOP_ERROR"
};

typedef enum {
	FSM_E000
} FSMError_t;

const char * const FSMErrorName[] = {
	"FSM_E000 : no error"
};

typedef enum {
	FSMT_NOP,
	FSMT_ABORT,
	FSMT_START,
	FSMT_STOP
} FSMTransitions_t;

const char * const FSMTransitions[] = {
	"FSMT_NOP: no operation",
	"FSMT_ABORT: abort FSM job",
	"FSMT_START: start scan",
	"FSMT_STOP: stop scan"
};


} /* namespace FSM_ns */

#endif /* _FSMTYPES_H_ */
