#include <AxisG2Scan.h>

namespace AxisG2Scan_ns
{

sp_ac_dc_t AxisG2Scan::getspacdc(string &msg){

	vector<Tango::DeviceAttribute> *devattr = NULL;
	vector<string> attr_names;
	sp_ac_dc_t axis_data;

	attr_names.push_back("Speed");
	attr_names.push_back("Acceleration");
	attr_names.push_back("Deceleration");
	attr_names.push_back("MotionAccuracy");

	axis_data.valid = false;

	try {
		devattr = axis_dp->read_attributes(attr_names);
        } catch(Tango::DevFailed e) {
        	Tango::Except::print_exception(e);
                cout << "---" << endl;
		string ss(ag2sc_error_str(AG2SC_E004));
		ss.append(" : exception on Tango::DeviceProxy(" + axisDevice + ")!");
		cout << ss << endl;
		msg += ss;
		if (devattr) {
			delete devattr;
			devattr = NULL;
		}
		throw;
	} catch (...) {
		string ss(ag2sc_error_str(AG2SC_E004));
		ss.append(" : exception on Tango::DeviceProxy(" + axisDevice + ")!");
		cout << ss << endl;
		msg += ss;
		if (devattr) {
			delete devattr;
			devattr = NULL;
		}
		throw;
	}


	if ( (*devattr).size() == 4 ) {
		(*devattr)[0] >>  axis_data.speed;
		(*devattr)[1] >>  axis_data.accel;
		(*devattr)[2] >>  axis_data.decel;
		(*devattr)[3] >>  axis_data.accuracy;
		axis_data.valid = true;
	} else {
		string ss(ag2sc_error_str(AG2SC_E005));
		ss.append(" : exception on Tango::DeviceProxy(" + axisDevice + ")!");
		cout << ss << endl;
		msg += ss;
		if (devattr) {
			delete devattr;
			devattr = NULL;
		}
		throw;
	}

	if (devattr) {
		delete devattr;
		devattr = NULL;
	}

	#ifdef _DBG_GETSPACDC
		cout << device_name << ".getspacdc() : axis_data.speed : " << axis_data.speed  << endl;
		cout << device_name << ".getspacdc() : axis_data.accel : " << axis_data.accel  << endl;
		cout << device_name << ".getspacdc() : axis_data.decel : " << axis_data.decel  << endl;
		cout << device_name << ".getspacdc() : axis_data.accuracy : " << axis_data.accuracy  << endl;
	#endif /* _DBG_GETSPACDC */

	return axis_data;
}
} //	namespace
