#include <AxisG2Scan.h>

namespace AxisG2Scan_ns
{
double AxisG2Scan::get_axis_position(){
	return get_axis_position(retfsm);
}

double AxisG2Scan::get_axis_position(FSM_ns::FSM_t _retfsm){

	#ifdef _PPC_PPC_
		vector<long> vl;
	#else
		vector<int> vl;
	#endif
	double pos = NAN;

	switch (_retfsm){
		case FSM_ns::FSM_SCAN_WAIT_TIME:
		case FSM_ns::FSM_SCAN_WAIT:
			#ifdef _DBG_GET_AXIS_POSITION
				cout << "get_axis_position(FSM_SCAN_WAIT or FSM_SCAN_WAIT_TIME)" << endl;
			#endif /* _DBG_GET_AXIS_POSITION */

			//================================
        		try {
				Tango::DeviceData dd;
				Tango::DeviceData ddout;
				Tango::DevVarLongArray argin;
				argin.length(3);
				argin[0] = channel_no;
				argin[1] = 0;
				argin[2] = 1;
				dd << argin;
                		ddout = axisBuffer_dp->command_inout("GetValues", dd);

				ddout >> vl;
				

				#ifdef _DBG_GET_AXIS_POSITION
				cout << __FILE__ << "@" << __LINE__ << " value:" << ddout  << " ";
				cout << "vl.size()=" << vl.size() << " argin[2]=" << argin[2] << " ";
				cout << endl;
				#endif /* _DBG_GET_AXIS_POSITION */

				#if 1
				if (vl.size() == (unsigned long)argin[2]){
					pos = per * (double)vl[0] + peo;
				}
				#else
					//ddout >> vl;
					//pos = per * (double)vl[0] + peo;
				#endif

        		} catch(Tango::DevFailed e) {
                		Tango::Except::print_exception(e);
        		} catch (...) {
                		cout << "err" << endl;
        		}
			//================================
			break;

		default:
			#ifdef _DBG_GET_AXIS_POSITION
				cout << "get_axis_position(default)" << endl;
			#endif /* _DBG_GET_AXIS_POSITION */

			try {
				Tango::DeviceAttribute da;

				da = axis_dp->read_attribute("Position");
				da >> pos;

        		} catch(Tango::DevFailed e) {
                		Tango::Except::print_exception(e);
        		} catch (...) {
                		cout << "err" << endl;
        		}
			break;
	}
	return  pos;
}


} // namespace
