#include <AxisG2Scan.h>

namespace AxisG2Scan_ns
{

Tango::DevState AxisG2Scan::get_axis_state(){

	#ifdef _PPC_PPC_
		vector<long> vl;
	#else
		vector<int> vl;
	#endif

	switch (retfsm){
		case FSM_ns::FSM_SCAN_WAIT:
			#ifdef _DBG_GET_AXIS_STATE
				cout << "get_axis_state(FSM_SCAN_WAIT)" << endl;
			#endif /* _DBG_GET_AXIS_STATE */

			//================================
        		try {
				Tango::DeviceData dd;
				Tango::DevVarLongArray argin;
				argin.length(3);
				argin[0] = channel_no;
				argin[1] = 0;
				argin[2] = 2;
				dd << argin;
                		dd = axisBuffer_dp->command_inout("GetValues", dd);
				//cout << dd << endl;

				dd >> vl;
				if (vl.size() == (unsigned long)argin[2]){
					if ( vl[0] != vl[1] ) {
						#ifdef _DBG_GET_AXIS_STATE
							cout << "get_axis_state(FSM_SCAN_WAIT) returning  Tango::MOVING" << endl;
						#endif /* _DBG_GET_AXIS_STATE */

						return  Tango::MOVING;
					} else {
						#ifdef _DBG_GET_AXIS_STATE
							cout << "get_axis_state() vl[0] == vl[1]" << endl;
						#endif /* _DBG_GET_AXIS_STATE */
						return Tango::UNKNOWN;
					}
				} else {
					#ifdef _DBG_GET_AXIS_STATE
						cout << "get_axis_state() vl.size() !== argin[2]" << endl;
					#endif /* _DBG_GET_AXIS_STATE */

					return  Tango::UNKNOWN;
				}

        		} catch(Tango::DevFailed e) {
                		Tango::Except::print_exception(e);
        		} catch (...) {
                		cout << "err" << endl;
        		}
		
			//================================

			return  Tango::UNKNOWN;
			break;
		default:
			#ifdef _DBG_GET_AXIS_STATE
				cout << "get_axis_state(default)" << endl;
			#endif /* _DBG_GET_AXIS_STATE */

			return  axis_dp->state();
			break;
	}
	return  Tango::UNKNOWN;
}


} // namespace
