#ifndef _UTILS_H_
#define _UTILS_H_
#include <string>       // std::string
#include <iostream>     // std::cout
#include <sstream>      // std::stringstream

#include <sys/time.h>
#include <string.h>

#define prtverbose(x, y, z)  _prtverbose(_name, _verbose, x, y, z)

inline void _prtverbose(std::string &_name, int _verbose, int level, std::string obj, std::string s){

  if ( level > _verbose ) return;

  struct timeval tv;

  gettimeofday(&tv, NULL);
  //time_t rawtime;
  struct tm * timeinfo;
  char buffer [80];
  char buffer2 [80];

  bzero(buffer2, 80);

  //time (&rawtime);
  //timeinfo = localtime (&rawtime);
  timeinfo = localtime (&tv.tv_sec);

  strftime (buffer,80,"%F %T",timeinfo);
  snprintf(buffer2, 80,".%03d ",(int)((float)tv.tv_usec/1000+0.5));

  std::string r("");
  r.append(buffer);
  r.append(buffer2);
  r.append(" " + _name + " ");
  if ( obj.size() >= 1 ){
      r.append(obj);
      r.append(" ");
  }
  r.append(s);

  std::cerr << r << std::endl;
}

#define prtverbose2(x, y, z)  _prtverbose2(_name, _verbose, x, y, z)

inline void _prtverbose2(std::string &_name, int _verbose, int level, std::string obj, std::string s){

  if ( level != _verbose ) return;

  time_t rawtime;
  struct tm * timeinfo;
  char buffer [80];

  time (&rawtime);
  timeinfo = localtime (&rawtime);

  strftime (buffer,80,"%F %T ",timeinfo);

  std::string r;
  r = _name +" ";
  r.append(buffer);

  if ( obj.size() >= 1 ){
      r.append(obj);
      r.append(" ");
  }
  r.append(s);

  std::cerr << r << std::endl;
}


//========================
inline std::string timestamp(){

  time_t rawtime;
  struct tm * timeinfo;
  char buffer [80];

  time (&rawtime);
  timeinfo = localtime (&rawtime);

  strftime (buffer,80,"%F %T ",timeinfo);

  std::string r;
  r = buffer;

  return r;
}
#endif  /*_UTILS_H_ */
